set serveroutput on size 10000;
set linesize 256;
define csize=500 
 
set verify off 
declare 
    Qmgr     CHAR(48) := 'TORPEDO';
    Qname    CHAR(48) := 'TEST.QUEUE';
    @MQSERIES.con
    hConn    binary_integer;
    hObj     binary_integer;
    CompCode binary_integer;
    Reason   binary_integer;
    mlen     binary_integer;
    od       mqpack.MQOD;
    md       mqpack.MQMD;
    gmo      mqpack.MQGMO;
    rawbuff  RAW(50)  := RPAD('0',99,'0');     /* must initialize */
    charbuff CHAR(50) := ' ';                  /* must initialize */
    O_Options  binary_integer;
    C_Options  binary_integer;
begin 
    mqpack.MQCONN(Qmgr,hConn,CompCode,Reason); 
    dbms_output.put_line('MQCONN: CompCode='||CompCode||' Reason='||Reason);
    od.ObjectName := Qname;
    O_Options := MQOO_INPUT_SHARED + MQOO_FAIL_IF_QUIESCING;
    mqpack.MQOPEN(hConn,od,O_Options,hObj,CompCode,Reason);
    dbms_output.put_line('MQOPEN: CompCode='||CompCode||' Reason='||Reason);
    gmo.Options := MQGMO_WAIT;
    gmo.WaitInterval := 15000; 
    mqpack.MQGET(hConn,hObj,md,gmo,50,rawbuff,mlen,CompCode,Reason);
    dbms_output.put_line('MQGET: CompCode='||CompCode||' Reason='||Reason);
    C_Options := MQCO_NONE;
    mqpack.MQCLOSE(hConn,hObj,C_Options,CompCode,Reason);
    dbms_output.put_line('MQCLOSE: CompCode='||CompCode||' Reason='||Reason);
    mqpack.MQDISC(hConn,CompCode,Reason);
    dbms_output.put_line('MQDISC: CompCode='||CompCode||' Reason='||Reason);
    mqpack.RAWtoCHAR(charbuff,1,50,rawbuff,1);
    dbms_output.put_line('message <'||charbuff||'>');
end; 
/ 
