#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "/usr/mqm/inc/cmqc.h"
#define z(x) ( (x==0) ? '.' : x )

void dump(char *buf, int size)
{
FILE *errors;
int count = 0;
int i;
char str[120];

   if( (errors=fopen("/t06/mqm/apps/plsql/dump.file", "a")) != NULL ){
      fprintf(errors, "----- (%d bytes)\n", size);
      for(i=0; i<size; i+=8){
         sprintf(str, "%2x %2x %2x %2x %2x %2x %2x %2x   %c %c %c %c %c %c %c %c\n",
            buf[i], buf[i+1], buf[i+2], buf[i+3], buf[i+4], buf[i+5], buf[i+6],
            buf[i+7], z(buf[i]), z(buf[i+1]), z(buf[i+2]), z(buf[i+3]), z(buf[i+4]), z(buf[i+5]),
            z(buf[i+6]), z(buf[i+7]));
         fprintf(errors, "%s", str);
      }
      fprintf(errors, "\n-----\n");
      fclose(errors);
   }
}

void mcpy(char *target, long tpos, long len, char *source, long spos)
{
   memcpy(target+tpos-1,source+spos-1,len);
}

void MQBOtoRAW(
         MQBO *rawMQBO,
         long *rawMQBO_len,
         char *StrucId,
         long *Version,
         long *Options)
{
   *rawMQBO_len=12;
   memcpy(rawMQBO->StrucId,StrucId,4);
   rawMQBO->Version=*Version;
   rawMQBO->Options=*Options;
}

void RAWtoMQBO(
         MQBO *rawMQBO,
         char *StrucId,
         long *Version,
         long *Options)
{
   memcpy(StrucId,rawMQBO->StrucId,4);
   *Version=rawMQBO->Version;
   *Options=rawMQBO->Options;
}

void MQCNOtoRAW(
         MQCNO *rawMQCNO,
         long *rawMQCNO_len,
         char *StrucId,
         long *Version,
         long *Options,
         long *ClientConnOffset,
         MQPTR *ClientConnPtr)
{
   *rawMQCNO_len=20;
   memcpy(rawMQCNO->StrucId,StrucId,4);
   rawMQCNO->Version=*Version;
   rawMQCNO->Options=*Options;
   rawMQCNO->ClientConnOffset=*ClientConnOffset;
   rawMQCNO->ClientConnPtr=*ClientConnPtr;
}

void RAWtoMQCNO(
         MQCNO *rawMQCNO,
         char *StrucId,
         long *Version,
         long *Options,
         long *ClientConnOffset,
         MQPTR *ClientConnPtr)
{
   memcpy(StrucId,rawMQCNO->StrucId,4);
   *Version=rawMQCNO->Version;
   *Options=rawMQCNO->Options;
   *ClientConnOffset=rawMQCNO->ClientConnOffset;
   *ClientConnPtr=rawMQCNO->ClientConnPtr;
}

void MQGMOtoRAW(
         MQGMO *rawMQGMO,
         long *rawMQGMO_len,
         char *StrucId,
         long *Version,
         long *Options,
         long *WaitInterval,
         long *Signal1,
         long *Signal2,
         char *ResolvedQName,
         long *MatchOptions,
         char *GroupStatus,
         char *SegmentStatus,
         char *Segmentation,
         char *Reserved1,
         char *MsgToken,
         long *ReturnedLength)
{
   *rawMQGMO_len=100;
   memcpy(rawMQGMO->StrucId,StrucId,4);
   rawMQGMO->Version=*Version;
   rawMQGMO->Options=*Options;
   rawMQGMO->WaitInterval=*WaitInterval;
   rawMQGMO->Signal1=*Signal1;
   rawMQGMO->Signal2=*Signal2;
   memcpy(rawMQGMO->ResolvedQName,ResolvedQName,MQ_Q_NAME_LENGTH);
   rawMQGMO->MatchOptions=*MatchOptions;
   memcpy(&(rawMQGMO->GroupStatus),GroupStatus,1);
   memcpy(&(rawMQGMO->SegmentStatus),SegmentStatus,1);
   memcpy(&(rawMQGMO->Segmentation),Segmentation,1);
   memcpy(&(rawMQGMO->Reserved1),Reserved1,1);
   memcpy(rawMQGMO->MsgToken,MsgToken,MQ_MSG_TOKEN_LENGTH);
   rawMQGMO->ReturnedLength=*ReturnedLength;
}

void RAWtoMQGMO(
         MQGMO *rawMQGMO,
         char *StrucId,
         long *Version,
         long *Options,
         long *WaitInterval,
         long *Signal1,
         long *Signal2,
         char *ResolvedQName,
         long *MatchOptions,
         char *GroupStatus,
         char *SegmentStatus,
         char *Segmentation,
         char *Reserved1,
         char *MsgToken,
         long *MsgToken_len,
         long *ReturnedLength)
{
   memcpy(StrucId,rawMQGMO->StrucId,4);
   *Version=rawMQGMO->Version;
   *Options=rawMQGMO->Options;
   *WaitInterval=rawMQGMO->WaitInterval;
   *Signal1=rawMQGMO->Signal1;
   *Signal2=rawMQGMO->Signal2;
   memcpy(ResolvedQName,rawMQGMO->ResolvedQName,MQ_Q_NAME_LENGTH);
   *MatchOptions=rawMQGMO->MatchOptions;
   memcpy(GroupStatus,&(rawMQGMO->GroupStatus),1);
   memcpy(SegmentStatus,&(rawMQGMO->SegmentStatus),1);
   memcpy(Segmentation,&(rawMQGMO->Segmentation),1);
   memcpy(Reserved1,&(rawMQGMO->Reserved1),1);
   memcpy(MsgToken,rawMQGMO->MsgToken,MQ_MSG_TOKEN_LENGTH);
   *MsgToken_len=MQ_MSG_TOKEN_LENGTH;
   *ReturnedLength=rawMQGMO->ReturnedLength;
}

void MQIIHtoRAW(
         MQIIH *rawMQIIH,
         long *rawMQIIH_len,
         char *StrucId,
         long *Version,
         long *StrucLength,
         long *Encoding,
         long *CodedCharSetId,
         char *Format,
         long *Flags,
         char *LTermOverride,
         char *MFSMapName,
         char *ReplyToFormat,
         char *Authenticator,
         char *TranInstanceId,
         char *TranState,
         char *CommitMode,
         char *SecurityScope,
         char *Reserved)
{
   *rawMQIIH_len=84;
   memcpy(rawMQIIH->StrucId,StrucId,4);
   rawMQIIH->Version=*Version;
   rawMQIIH->StrucLength=*StrucLength;
   rawMQIIH->Encoding=*Encoding;
   rawMQIIH->CodedCharSetId=*CodedCharSetId;
   memcpy(rawMQIIH->Format,Format,MQ_FORMAT_LENGTH);
   rawMQIIH->Flags=*Flags;
   memcpy(rawMQIIH->LTermOverride,LTermOverride,MQ_LTERM_OVERRIDE_LENGTH);
   memcpy(rawMQIIH->MFSMapName,MFSMapName,MQ_MFS_MAP_NAME_LENGTH);
   memcpy(rawMQIIH->ReplyToFormat,ReplyToFormat,MQ_FORMAT_LENGTH);
   memcpy(rawMQIIH->Authenticator,Authenticator,MQ_AUTHENTICATOR_LENGTH);
   memcpy(rawMQIIH->TranInstanceId,TranInstanceId,MQ_TRAN_INSTANCE_ID_LENGTH);
   memcpy(&(rawMQIIH->TranState),TranState,1);
   memcpy(&(rawMQIIH->CommitMode),CommitMode,1);
   memcpy(&(rawMQIIH->SecurityScope),SecurityScope,1);
   memcpy(&(rawMQIIH->Reserved),Reserved,1);
}

void RAWtoMQIIH(
         MQIIH *rawMQIIH,
         char *StrucId,
         long *Version,
         long *StrucLength,
         long *Encoding,
         long *CodedCharSetId,
         char *Format,
         long *Flags,
         char *LTermOverride,
         char *MFSMapName,
         char *ReplyToFormat,
         char *Authenticator,
         char *TranInstanceId,
         long *TranInstanceId_len,
         char *TranState,
         char *CommitMode,
         char *SecurityScope,
         char *Reserved)
{
   memcpy(StrucId,rawMQIIH->StrucId,84);
   *Version=rawMQIIH->Version;
   *StrucLength=rawMQIIH->StrucLength;
   *Encoding=rawMQIIH->Encoding;
   *CodedCharSetId=rawMQIIH->CodedCharSetId;
   memcpy(Format,rawMQIIH->Format,MQ_FORMAT_LENGTH);
   *Flags=rawMQIIH->Flags;
   memcpy(LTermOverride,rawMQIIH->LTermOverride,MQ_LTERM_OVERRIDE_LENGTH);
   memcpy(MFSMapName,rawMQIIH->MFSMapName,MQ_MFS_MAP_NAME_LENGTH);
   memcpy(ReplyToFormat,rawMQIIH->ReplyToFormat,MQ_FORMAT_LENGTH);
   memcpy(Authenticator,rawMQIIH->Authenticator,MQ_AUTHENTICATOR_LENGTH);
   memcpy(TranInstanceId,rawMQIIH->TranInstanceId,MQ_TRAN_INSTANCE_ID_LENGTH);
   *TranInstanceId_len=MQ_TRAN_INSTANCE_ID_LENGTH;
   memcpy(TranState,&(rawMQIIH->TranState),1);
   memcpy(CommitMode,&(rawMQIIH->CommitMode),1);
   memcpy(SecurityScope,&(rawMQIIH->SecurityScope),1);
   memcpy(Reserved,&(rawMQIIH->Reserved),1);
}

void MQODtoRAW(
         MQOD *rawMQOD,
         long *rawMQOD_len,
         char *StrucId,
         long *Version,
         long *ObjectType,
         char *ObjectName,
         char *ObjectQMgrName,
         char *DynamicQName,
         char *AlternateUserId,
         long *RecsPresent,
         long *KnownDestCount,
         long *UnknownDestCount,
         long *InvalidDestCount,
         long *ObjectRecOffset,
         long *ResponseRecOffset,
         MQPTR *ObjectRecPtr,
         MQPTR *ResponseRecPtr,
         char *AlternateSecurityId,
         char *ResolvedQName,
         char *ResolvedQMgrName)
{
   *rawMQOD_len=MQOD_CURRENT_LENGTH;
   memcpy(rawMQOD->StrucId,StrucId,4);
   rawMQOD->Version=*Version;
   rawMQOD->ObjectType=*ObjectType;
   memcpy(rawMQOD->ObjectName,ObjectName,MQ_OBJECT_NAME_LENGTH);
   memcpy(rawMQOD->ObjectQMgrName,ObjectQMgrName,MQ_Q_MGR_NAME_LENGTH);
   memcpy(rawMQOD->DynamicQName,DynamicQName,MQ_Q_NAME_LENGTH);
   memcpy(rawMQOD->AlternateUserId,AlternateUserId,MQ_USER_ID_LENGTH);
   rawMQOD->RecsPresent=*RecsPresent;
   rawMQOD->KnownDestCount=*KnownDestCount;
   rawMQOD->UnknownDestCount=*UnknownDestCount;
   rawMQOD->InvalidDestCount=*InvalidDestCount;
   rawMQOD->ObjectRecOffset=*ObjectRecOffset;
   rawMQOD->ResponseRecOffset=*ResponseRecOffset;
   rawMQOD->ObjectRecPtr=*ObjectRecPtr;
   rawMQOD->ResponseRecPtr=*ResponseRecPtr;
   memcpy(rawMQOD->AlternateSecurityId,AlternateSecurityId,MQ_SECURITY_ID_LENGTH);
   memcpy(rawMQOD->ResolvedQName,ResolvedQName,MQ_Q_NAME_LENGTH);
   memcpy(rawMQOD->ResolvedQMgrName,ResolvedQMgrName,MQ_Q_MGR_NAME_LENGTH);
}

void RAWtoMQOD(
         MQOD *rawMQOD,
         char *StrucId,
         long *Version,
         long *ObjectType,
         char *ObjectName,
         char *ObjectQMgrName,
         char *DynamicQName,
         char *AlternateUserId,
         long *RecsPresent,
         long *KnownDestCount,
         long *UnknownDestCount,
         long *InvalidDestCount,
         long *ObjectRecOffset,
         long *ResponseRecOffset,
         MQPTR *ObjectRecPtr,
         MQPTR *ResponseRecPtr,
         char *AlternateSecurityId,
         long *AlternateSecurityId_len,
         char *ResolvedQName,
         char *ResolvedQMgrName)
{
   memcpy(StrucId,rawMQOD->StrucId,4);
   *Version=rawMQOD->Version;
   *ObjectType=rawMQOD->ObjectType;
   memcpy(ObjectName,rawMQOD->ObjectName,MQ_OBJECT_NAME_LENGTH);
   memcpy(ObjectQMgrName,rawMQOD->ObjectQMgrName,MQ_Q_MGR_NAME_LENGTH);
   memcpy(DynamicQName,rawMQOD->DynamicQName,MQ_Q_NAME_LENGTH);
   memcpy(AlternateUserId,rawMQOD->AlternateUserId,MQ_USER_ID_LENGTH);
   *RecsPresent=rawMQOD->RecsPresent;
   *KnownDestCount=rawMQOD->KnownDestCount;
   *UnknownDestCount=rawMQOD->UnknownDestCount;
   *InvalidDestCount=rawMQOD->InvalidDestCount;
   *ObjectRecOffset=rawMQOD->ObjectRecOffset;
   *ResponseRecOffset=rawMQOD->ResponseRecOffset;
   *ObjectRecPtr=rawMQOD->ObjectRecPtr;
   *ResponseRecPtr=rawMQOD->ResponseRecPtr;
   memcpy(AlternateSecurityId,rawMQOD->AlternateSecurityId,MQ_SECURITY_ID_LENGTH);
   *AlternateSecurityId_len=MQ_SECURITY_ID_LENGTH;
   memcpy(ResolvedQName,rawMQOD->ResolvedQName,MQ_Q_NAME_LENGTH);
   memcpy(ResolvedQMgrName,rawMQOD->ResolvedQMgrName,MQ_Q_MGR_NAME_LENGTH);
}

void MQMDtoRAW(
         MQMD *rawMQMD,
         long *rawMQMD_len,
         char *StrucId,
         long *Version,
         long *Report,
         long *MsgType,
         long *Expiry,
         long *Feedback,
         long *Encoding,
         long *CodedCharSetId,
         char *Format,
         long *Priority,
         long *Persistence,
         char *MsgId,
         char *CorrelId,
         long *BackoutCount,
         char *ReplyToQ,
         char *ReplyToQMgr,
         char *UserIdentifier,
         char *AccountingToken,
         char *ApplIdentityData,
         long *PutApplType,
         char *PutApplName,
         char *PutDate,
         char *PutTime,
         char *ApplOriginData,
         char *GroupId,
         long *MsgSeqNumber,
         long *Offset,
         long *MsgFlags,
         long *OriginalLength)
{
   *rawMQMD_len=364;
   memcpy(rawMQMD->StrucId,StrucId,4);
   rawMQMD->Version=*Version;
   rawMQMD->Report=*Report;
   rawMQMD->MsgType=*MsgType;
   rawMQMD->Expiry=*Expiry;
   rawMQMD->Feedback=*Feedback;
   rawMQMD->Encoding=*Encoding;
   rawMQMD->CodedCharSetId=*CodedCharSetId;
   memcpy(rawMQMD->Format,Format,MQ_FORMAT_LENGTH);
   rawMQMD->Priority=*Priority;
   rawMQMD->Persistence=*Persistence;
   memcpy(rawMQMD->MsgId,MsgId,MQ_MSG_ID_LENGTH);
   memcpy(rawMQMD->CorrelId,CorrelId,MQ_CORREL_ID_LENGTH);
   rawMQMD->BackoutCount=*BackoutCount;
   memcpy(rawMQMD->ReplyToQ,ReplyToQ,MQ_Q_NAME_LENGTH);
   memcpy(rawMQMD->ReplyToQMgr,ReplyToQMgr,MQ_Q_MGR_NAME_LENGTH);
   memcpy(rawMQMD->UserIdentifier,UserIdentifier,MQ_USER_ID_LENGTH);
   memcpy(rawMQMD->AccountingToken,AccountingToken,MQ_ACCOUNTING_TOKEN_LENGTH);
   memcpy(rawMQMD->ApplIdentityData,ApplIdentityData,MQ_APPL_IDENTITY_DATA_LENGTH);
   rawMQMD->PutApplType=*PutApplType;
   memcpy(rawMQMD->PutApplName,PutApplName,MQ_PUT_APPL_NAME_LENGTH);
   memcpy(rawMQMD->PutDate,PutDate,MQ_PUT_DATE_LENGTH);
   memcpy(rawMQMD->PutTime,PutTime,MQ_PUT_TIME_LENGTH);
   memcpy(rawMQMD->ApplOriginData,ApplOriginData,MQ_APPL_ORIGIN_DATA_LENGTH);
   memcpy(rawMQMD->GroupId,GroupId,MQ_GROUP_ID_LENGTH);
   rawMQMD->MsgSeqNumber=*MsgSeqNumber;
   rawMQMD->Offset=*Offset;
   rawMQMD->MsgFlags=*MsgFlags;
   rawMQMD->OriginalLength=*OriginalLength;
}

void RAWtoMQMD(
         MQMD *rawMQMD,
         char *StrucId,
         long *Version,
         long *Report,
         long *MsgType,
         long *Expiry,
         long *Feedback,
         long *Encoding,
         long *CodedCharSetId,
         char *Format,
         long *Priority,
         long *Persistence,
         char *MsgId,
         long *MsgId_len,
         char *CorrelId,
         long *CorrelId_len,
         long *BackoutCount,
         char *ReplyToQ,
         char *ReplyToQMgr,
         char *UserIdentifier,
         char *AccountingToken,
         long *AccountingToken_len,
         char *ApplIdentityData,
         long *PutApplType,
         char *PutApplName,
         char *PutDate,
         char *PutTime,
         char *ApplOriginData,
         char *GroupId,
         long *GroupId_len,
         long *MsgSeqNumber,
         long *Offset,
         long *MsgFlags,
         long *OriginalLength)
{
   memcpy(StrucId,rawMQMD->StrucId,4);
   *Version=rawMQMD->Version;
   *Report=rawMQMD->Report;
   *MsgType=rawMQMD->MsgType;
   *Expiry=rawMQMD->Expiry;
   *Feedback=rawMQMD->Feedback;
   *Encoding=rawMQMD->Encoding;
   *CodedCharSetId=rawMQMD->CodedCharSetId;
   memcpy(Format,rawMQMD->Format,MQ_FORMAT_LENGTH);
   *Priority=rawMQMD->Priority;
   *Persistence=rawMQMD->Persistence;
   memcpy(MsgId,rawMQMD->MsgId,MQ_MSG_ID_LENGTH);
   *MsgId_len=MQ_MSG_ID_LENGTH;
   memcpy(CorrelId,rawMQMD->CorrelId,MQ_CORREL_ID_LENGTH);
   *CorrelId_len=MQ_CORREL_ID_LENGTH;
   *BackoutCount=rawMQMD->BackoutCount;
   memcpy(ReplyToQ,rawMQMD->ReplyToQ,MQ_Q_NAME_LENGTH);
   memcpy(ReplyToQMgr,rawMQMD->ReplyToQMgr,MQ_Q_MGR_NAME_LENGTH);
   memcpy(UserIdentifier,rawMQMD->UserIdentifier,MQ_USER_ID_LENGTH);
   memcpy(AccountingToken,rawMQMD->AccountingToken,MQ_ACCOUNTING_TOKEN_LENGTH);
   *AccountingToken_len=MQ_ACCOUNTING_TOKEN_LENGTH;
   memcpy(ApplIdentityData,rawMQMD->ApplIdentityData,MQ_APPL_IDENTITY_DATA_LENGTH);
   *PutApplType=rawMQMD->PutApplType;
   memcpy(PutApplName,rawMQMD->PutApplName,MQ_PUT_APPL_NAME_LENGTH);
   memcpy(PutDate,rawMQMD->PutDate,MQ_PUT_DATE_LENGTH);
   memcpy(PutTime,rawMQMD->PutTime,MQ_PUT_TIME_LENGTH);
   memcpy(ApplOriginData,rawMQMD->ApplOriginData,MQ_APPL_ORIGIN_DATA_LENGTH);
   memcpy(GroupId,rawMQMD->GroupId,MQ_GROUP_ID_LENGTH);
   *GroupId_len=MQ_GROUP_ID_LENGTH;
   *MsgSeqNumber=rawMQMD->MsgSeqNumber;
   *Offset=rawMQMD->Offset;
   *MsgFlags=rawMQMD->MsgFlags;
   *OriginalLength=rawMQMD->OriginalLength;
}

void MQPMOtoRAW(
         MQPMO *rawMQPMO,
         long *rawMQPMO_len,
         char *StrucId,
         long *Version,
         long *Options,
         long *Timeout,
         long *Context,
         long *KnownDestCount,
         long *UnknownDestCount,
         long *InvalidDestCount,
         char *ResolvedQName,
         char *ResolvedQMgrName,
         long *RecsPresent,
         long *PutMsgRecFields,
         long *PutMsgRecOffset,
         long *ResponseRecOffset,
         MQPTR *PutMsgRecPtr,
         MQPTR *ResponseRecPtr)
{
   *rawMQPMO_len=152;
   memcpy(rawMQPMO->StrucId,StrucId,4);
   rawMQPMO->Version=*Version;
   rawMQPMO->Options=*Options;
   rawMQPMO->Timeout=*Timeout;
   rawMQPMO->Context=*Context;
   rawMQPMO->KnownDestCount=*KnownDestCount;
   rawMQPMO->UnknownDestCount=*UnknownDestCount;
   rawMQPMO->InvalidDestCount=*InvalidDestCount;
   memcpy(rawMQPMO->ResolvedQName,ResolvedQName,MQ_Q_NAME_LENGTH);
   memcpy(rawMQPMO->ResolvedQMgrName,ResolvedQMgrName,MQ_Q_MGR_NAME_LENGTH);
   rawMQPMO->RecsPresent=*RecsPresent;
   rawMQPMO->PutMsgRecFields=*PutMsgRecFields;
   rawMQPMO->PutMsgRecOffset=*PutMsgRecOffset;
   rawMQPMO->ResponseRecOffset=*ResponseRecOffset;
   rawMQPMO->PutMsgRecPtr=*PutMsgRecPtr;
   rawMQPMO->ResponseRecPtr=*ResponseRecPtr;
}

void RAWtoMQPMO(
         MQPMO *rawMQPMO,
         char *StrucId,
         long *Version,
         long *Options,
         long *Timeout,
         long *Context,
         long *KnownDestCount,
         long *UnknownDestCount,
         long *InvalidDestCount,
         char *ResolvedQName,
         char *ResolvedQMgrName,
         long *RecsPresent,
         long *PutMsgRecFields,
         long *PutMsgRecOffset,
         long *ResponseRecOffset,
         MQPTR *PutMsgRecPtr,
         MQPTR *ResponseRecPtr)
{
   memcpy(StrucId,rawMQPMO->StrucId,4);
   *Version=rawMQPMO->Version;
   *Options=rawMQPMO->Options;
   *Timeout=rawMQPMO->Timeout;
   *Context=rawMQPMO->Context;
   *KnownDestCount=rawMQPMO->KnownDestCount;
   *UnknownDestCount=rawMQPMO->UnknownDestCount;
   *InvalidDestCount=rawMQPMO->InvalidDestCount;
   memcpy(ResolvedQName,rawMQPMO->ResolvedQName,MQ_Q_NAME_LENGTH);
   memcpy(ResolvedQMgrName,rawMQPMO->ResolvedQMgrName,MQ_Q_MGR_NAME_LENGTH);
   *RecsPresent=rawMQPMO->RecsPresent;
   *PutMsgRecFields=rawMQPMO->PutMsgRecFields;
   *PutMsgRecOffset=rawMQPMO->PutMsgRecOffset;
   *ResponseRecOffset=rawMQPMO->ResponseRecOffset;
   *PutMsgRecPtr=rawMQPMO->PutMsgRecPtr;
   *ResponseRecPtr=rawMQPMO->ResponseRecPtr;
}


