set serveroutput on size 10000;
set linesize 256;
define csize=500 
 
set verify off 
declare 
    @MQSERIES.con
    Qmgr     CHAR(48) := 'TORPEDO';
    TargetQ  CHAR(48) := 'TIMS.INPUT.QUEUE';
    ReplyQ   CHAR(48) := 'TIMS.REPLY.QUEUE';
    Userid   CHAR(12) := 'GRACF';
    Password CHAR(8)  := 'GRACF';
    hConn    binary_integer;
    hObj     binary_integer;
    CompCode binary_integer;
    Reason   binary_integer;
    mlen     binary_integer;
    od       mqpack.MQOD;
    odr      mqpack.MQOD;
    md       mqpack.MQMD;
    mdr      mqpack.MQMD;
    pmo      mqpack.MQPMO;
    gmo      mqpack.MQGMO;
    iih      mqpack.MQIIH;
    rawiih   RAW(84)  := RPAD('0',167,'0');
    imsLLZZ  RAW(4)   := '00680000';             /* LL=104 (length if IIH + LLZZ + MSG) */
    imsMSG   CHAR(16) := 'IMSCHK  mqtest  ';
    rawbuff  RAW(104)  := RPAD('0',207,'0');     /* must initialize */
    charbuff CHAR(104) := ' ';
    outbuff  RAW(500)  := RPAD('0',999,'0');     /* must initialize */
    O_Options  binary_integer;
    C_Options  binary_integer;
begin 
 
    mqpack.MQCONN(Qmgr,hConn,CompCode,Reason); 
    dbms_output.put_line('MQCONN: CompCode='||CompCode||' Reason='||Reason);
 
    od.ObjectName := TargetQ;
    O_Options := MQOO_OUTPUT + MQOO_FAIL_IF_QUIESCING + MQOO_SET_IDENTITY_CONTEXT;
    mqpack.MQOPEN(hConn,od,O_Options,hObj,CompCode,Reason);
    dbms_output.put_line('MQOPEN(T): CompCode='||CompCode||' Reason='||Reason);
 
    md.ReplyToQ := ReplyQ;
    md.ReplyToQMgr := Qmgr;
    md.UserIdentifier := Userid;
    md.Format := MQFMT_IMS;
    md.Persistence := MQPER_PERSISTENT;
    md.Report := MQRO_PASS_MSG_ID;
    iih.Authenticator := Password;
    iih.Format := MQFMT_IMS_VAR_STRING;
    iih.ReplyToFormat := MQFMT_IMS_VAR_STRING;
    iih.CommitMode := MQICM_COMMIT_THEN_SEND;
    mqpack.MQIIHtoRAW(rawiih,iih);             /* convert iih to raw         */
    mqpack.RAWTORAW(rawbuff,1,84,rawiih,1);    /* move iih to buffer         */
    mqpack.RAWTORAW(rawbuff,85,4,imsLLZZ,1);   /* move LLZZ to buffer        */
    mqpack.CHARTORAW(rawbuff,89,16,imsMSG,1);  /* move IMS message to buffer */

    pmo.Options := MQPMO_NEW_MSG_ID + MQPMO_SET_IDENTITY_CONTEXT;
    mqpack.MQPUT(hConn,hObj,md,pmo,104,rawbuff,CompCode,Reason);
    dbms_output.put_line('MQPUT: CompCode='||CompCode||' Reason='||Reason);

    C_Options := MQCO_NONE;
    mqpack.MQCLOSE(hConn,hObj,C_Options,CompCode,Reason);
    dbms_output.put_line('MQCLOSE(T): CompCode='||CompCode||' Reason='||Reason);

    odr.ObjectName := ReplyQ;
    O_Options := MQOO_INPUT_SHARED + MQOO_FAIL_IF_QUIESCING;
    mqpack.MQOPEN(hConn,odr,O_Options,hObj,CompCode,Reason);
    dbms_output.put_line('MQOPEN(R): CompCode='||CompCode||' Reason='||Reason);

    gmo.Options := MQGMO_WAIT + MQGMO_CONVERT + MQGMO_ACCEPT_TRUNCATED_MSG;
    gmo.WaitInterval := 15000;       /* 15 seconds */
    mdr.Encoding := MQENC_NATIVE;
    mdr.CodedCharSetId := MQCCSI_Q_MGR;
    mdr.MsgId := md.MsgId;
    mqpack.MQGET(hConn,hObj,mdr,gmo,500,outbuff,mlen,CompCode,Reason);
    dbms_output.put_line('MQGET: CompCode='||CompCode||' Reason='||Reason);

    if CompCode = MQCC_WARNING then
       if mdr.Format = MQFMT_DEAD_LETTER_HEADER then
          dbms_output.put_line('  Message rejected by IMS bridge');
       end if;
    end if;
    if CompCode = MQCC_OK then
       mqpack.RAWTOCHAR(charbuff,1,8,outbuff,89);     
       dbms_output.put_line('Msg: <'||substr(charbuff,1,8)||'>');
    end if;
    
    C_Options := MQCO_NONE;
    mqpack.MQCLOSE(hConn,hObj,C_Options,CompCode,Reason);
    dbms_output.put_line('MQCLOSE(R): CompCode='||CompCode||' Reason='||Reason);
 
    mqpack.MQDISC(hConn,CompCode,Reason);
    dbms_output.put_line('MQDISC: CompCode='||CompCode||' Reason='||Reason);
 
end; 
/ 
