CREATE OR REPLACE LIBRARY mqulib IS '&1';
/
CREATE OR REPLACE LIBRARY mqslib IS '&2';
/
CREATE OR REPLACE LIBRARY mqulib1 IS '&3';
/
 
CREATE OR REPLACE PACKAGE mqpack IS
 
  @MQSERIES.con
  @MQSERIES.def
 
  /* External memory copy routines */
  FUNCTION xasql(dbname          IN CHAR,
                 procedure_name  IN CHAR,
                 parm1           IN BINARY_INTEGER) RETURN BINARY_INTEGER;

  FUNCTION xasqlpc(dbname          IN CHAR,
                 procedure_name  IN CHAR,
                 parm1           IN BINARY_INTEGER) RETURN BINARY_INTEGER;

  FUNCTION xasql(dbname          IN CHAR,
                 procedure_name  IN CHAR,
                 parm1           IN VARCHAR) RETURN BINARY_INTEGER;

  FUNCTION xasqlpc(dbname          IN CHAR,
                 procedure_name  IN CHAR,
                 parm1           IN VARCHAR) RETURN BINARY_INTEGER;

  FUNCTION xasec(dbname          IN CHAR,
                 procedure_name  IN CHAR) RETURN BINARY_INTEGER;

  PROCEDURE CHARtoRAW(outraw  IN OUT RAW,
                      rawpos  IN     BINARY_INTEGER,
                      rawlen  IN     BINARY_INTEGER,
                      inchar  IN     CHAR,
                      charpos IN     BINARY_INTEGER);
 
  PROCEDURE RAWtoCHAR(outchar IN OUT CHAR,
                      charpos IN     BINARY_INTEGER,
                      charlen IN     BINARY_INTEGER,
                      inraw   IN     RAW,
                      rawpos  IN     BINARY_INTEGER);
 
  PROCEDURE RAWtoRAW(outraw   IN OUT RAW,
                      raw1pos IN     BINARY_INTEGER,
                      raw1len IN     BINARY_INTEGER,
                      inraw   IN     RAW,
                      raw2pos IN     BINARY_INTEGER);
  
  PROCEDURE RAWtoVARCHAR(outvc    IN OUT VARCHAR,
                      vcpos    IN     BINARY_INTEGER,
                      vclen    IN     BINARY_INTEGER,
                      inraw    IN     RAW,
                      rawpos   IN     BINARY_INTEGER);
 
  PROCEDURE VARCHARtoRAW(outraw   IN OUT RAW,
                      rawpos   IN     BINARY_INTEGER,
                      rawlen   IN     BINARY_INTEGER,
                      invc     IN     VARCHAR,
                      vcpos    IN     BINARY_INTEGER);

  /* External MQSeries routines */
 
  PROCEDURE MQBEGIN(Hconn       IN     BINARY_INTEGER,
                   bo      IN OUT RAW,
                   CompCode   OUT BINARY_INTEGER,
                   Reason     OUT BINARY_INTEGER);
 
  PROCEDURE MQCONN(QMgrName IN     CHAR,
                   Hconn       OUT BINARY_INTEGER,
                   CompCode    OUT BINARY_INTEGER,
                   Reason      OUT BINARY_INTEGER);
 
  PROCEDURE MQCONNX(QMgrName IN         CHAR,
                   cno      IN OUT RAW,
                   Hconn       OUT BINARY_INTEGER,
                   CompCode    OUT BINARY_INTEGER,
                   Reason      OUT BINARY_INTEGER);
 
  PROCEDURE MQOPEN(Hconn IN         BINARY_INTEGER,
                   od        IN OUT RAW,
                   Options   IN     BINARY_INTEGER,
                   Hobj         OUT BINARY_INTEGER,
                   CompCode     OUT BINARY_INTEGER,
                   Reason       OUT BINARY_INTEGER);
  PROCEDURE MQGET(Hconn        IN     BINARY_INTEGER,
                  Hobj     IN     BINARY_INTEGER,
                  md       IN OUT RAW,
                  gmo      IN OUT RAW,
                  len      IN     BINARY_INTEGER,
                  buff     IN OUT RAW,
                  mlen        OUT BINARY_INTEGER,
                  CompCode    OUT BINARY_INTEGER,
                  Reason      OUT BINARY_INTEGER);
 
  PROCEDURE MQPUT(Hconn        IN     BINARY_INTEGER,
                  Hobj     IN     BINARY_INTEGER,
                  md       IN OUT RAW,
                  pmo      IN OUT RAW,
                  len      IN     BINARY_INTEGER,
                  buff     IN OUT RAW,
                  CompCode    OUT BINARY_INTEGER,
                  Reason      OUT BINARY_INTEGER);
 
  PROCEDURE MQPUT1(Hconn        IN     BINARY_INTEGER,
                  od       IN OUT RAW,
                  md       IN OUT RAW,
                  pmo      IN OUT RAW,
                  len      IN     BINARY_INTEGER,
                  buff     IN OUT RAW,
                  CompCode    OUT BINARY_INTEGER,
                  Reason      OUT BINARY_INTEGER);
 
  PROCEDURE MQCLOSE(Hconn  IN     BINARY_INTEGER,
                  Hobj     IN     BINARY_INTEGER,
                  Options  IN     BINARY_INTEGER,
                  CompCode    OUT BINARY_INTEGER,
                  Reason      OUT BINARY_INTEGER);
 
  PROCEDURE MQDISC(Hconn  IN      BINARY_INTEGER,
                  CompCode    OUT BINARY_INTEGER,
                  Reason      OUT BINARY_INTEGER);
 
  PROCEDURE MQBACK(Hconn  IN      BINARY_INTEGER,
                  CompCode    OUT BINARY_INTEGER,
                  Reason      OUT BINARY_INTEGER);
 
  PROCEDURE MQCMIT(Hconn  IN      BINARY_INTEGER,
                  CompCode    OUT BINARY_INTEGER,
                  Reason      OUT BINARY_INTEGER);
 
  /* Internal PLSQL MQSeries routines */
 
  PROCEDURE MQBEGIN(Hconn   IN     BINARY_INTEGER,
                   bo       IN OUT MQBO,
                   CompCode    OUT BINARY_INTEGER,
                   Reason      OUT BINARY_INTEGER);
 
  PROCEDURE MQCONNX(QMgrName IN     CHAR,
                   cno       IN OUT MQCNO,
                   Hconn        OUT BINARY_INTEGER,
                   CompCode     OUT BINARY_INTEGER,
                   Reason       OUT BINARY_INTEGER);
 
  PROCEDURE MQOPEN(Hconn   IN     BINARY_INTEGER,
                   od      IN OUT MQOD,
                   Options IN     BINARY_INTEGER,
                   Hobj       OUT BINARY_INTEGER,
                   CompCode   OUT BINARY_INTEGER,
                   Reason     OUT BINARY_INTEGER);
 
  PROCEDURE MQGET(Hconn    IN     BINARY_INTEGER,
                  Hobj     IN     BINARY_INTEGER,
                  md       IN OUT MQMD,
                  gmo      IN OUT MQGMO,
                  len      IN     BINARY_INTEGER,
                  buff     IN OUT RAW,
                  mlen        OUT BINARY_INTEGER,
                  CompCode    OUT BINARY_INTEGER,
                  Reason      OUT BINARY_INTEGER);
 
  PROCEDURE MQPUT(Hconn    IN     BINARY_INTEGER,
                  Hobj     IN     BINARY_INTEGER,
                  md       IN OUT MQMD,
                  pmo      IN OUT MQPMO,
                  len      IN     BINARY_INTEGER,
                  buff     IN OUT RAW,
                  CompCode    OUT BINARY_INTEGER,
                  Reason      OUT BINARY_INTEGER);
 
  PROCEDURE MQPUT1(Hconn    IN     BINARY_INTEGER,
                  od       IN OUT MQOD,
                  md       IN OUT MQMD,
                  pmo      IN OUT MQPMO,
                  len      IN     BINARY_INTEGER,
                  buff     IN OUT RAW,
                  CompCode    OUT BINARY_INTEGER,
                  Reason      OUT BINARY_INTEGER);
 
  /* MQSeries structure to PLSQL RAW conversion routines */
 
  PROCEDURE MQBOtoRAW(
      rawMQBO              IN OUT RAW,
      StrucId              IN CHAR,
      Version              IN BINARY_INTEGER,
      Options              IN BINARY_INTEGER
      ); 
  PROCEDURE MQBOtoRAW(
      rawMQBO              IN OUT RAW,
      bo                   IN     MQBO);
 
  PROCEDURE MQCNOtoRAW(
      rawMQCNO             IN OUT RAW,
      StrucId              IN CHAR,
      Version              IN BINARY_INTEGER,
      Options              IN BINARY_INTEGER,
      ClientConnOffset     IN BINARY_INTEGER,
      ClientConnPtr        IN BINARY_INTEGER
      ); 
  PROCEDURE MQCNOtoRAW(
      rawMQCNO             IN OUT RAW,
      cno                  IN     MQCNO);
 
  PROCEDURE MQGMOtoRAW(
      rawMQGMO             IN OUT RAW,
      StrucId              IN CHAR,
      Version              IN BINARY_INTEGER,
      Options              IN BINARY_INTEGER,
      WaitInterval         IN BINARY_INTEGER,
      Signal1              IN BINARY_INTEGER,
      Signal2              IN BINARY_INTEGER,
      ResolvedQName        IN CHAR,
      MatchOptions         IN BINARY_INTEGER,
      GroupStatus          IN CHAR,
      SegmentStatus        IN CHAR,
      Segmentation         IN CHAR,
      Reserved1            IN CHAR,
      MsgToken             IN RAW,
      ReturnedLength       IN BINARY_INTEGER
      ); 
  PROCEDURE MQGMOtoRAW(
      rawMQGMO             IN OUT RAW,
      gmo                  IN     MQGMO);
 
  PROCEDURE MQIIHtoRAW(
      rawMQIIH             IN OUT RAW,
      StrucId              IN CHAR,
      Version              IN BINARY_INTEGER,
      StrucLength          IN BINARY_INTEGER,
      Encoding             IN BINARY_INTEGER,
      CodedCharSetId       IN BINARY_INTEGER,
      Format               IN CHAR,
      Flags                IN BINARY_INTEGER,
      LTermOverride        IN CHAR,
      MFSMapName           IN CHAR,
      ReplyToFormat        IN CHAR,
      Authenticator        IN CHAR,
      TranInstanceId       IN RAW,
      TranState            IN CHAR,
      CommitMode           IN CHAR,
      SecurityScope        IN CHAR,
      Reserved             IN CHAR
      ); 
  PROCEDURE MQIIHtoRAW(
      rawMQIIH             IN OUT RAW,
      iih                  IN     MQIIH);
 
  PROCEDURE MQMDtoRAW(
      rawMQMD              IN OUT RAW,
      StrucId              IN CHAR,
      Version              IN BINARY_INTEGER,
      Report               IN BINARY_INTEGER,
      MsgType              IN BINARY_INTEGER,
      Expiry               IN BINARY_INTEGER,
      Feedback             IN BINARY_INTEGER,
      Encoding             IN BINARY_INTEGER,
      CodedCharSetId       IN BINARY_INTEGER,
      Format               IN CHAR,
      Priority             IN BINARY_INTEGER,
      Persistence          IN BINARY_INTEGER,
      MsgId                IN RAW,
      CorrelId             IN RAW,
      BackoutCount         IN BINARY_INTEGER,
      ReplyToQ             IN CHAR,
      ReplyToQMgr          IN CHAR,
      UserIdentifier       IN CHAR,
      AccountingToken      IN RAW,
      ApplIdentityData     IN CHAR,
      PutApplType          IN BINARY_INTEGER,
      PutApplName          IN CHAR,
      PutDate              IN CHAR,
      PutTime              IN CHAR,
      ApplOriginData       IN CHAR,
      GroupId              IN RAW,
      MsgSeqNumber         IN BINARY_INTEGER,
      Offset               IN BINARY_INTEGER,
      MsgFlags             IN BINARY_INTEGER,
      OriginalLength       IN BINARY_INTEGER
      ); 
  PROCEDURE MQMDtoRAW(
      rawMQMD              IN OUT RAW,
      md                   IN     MQMD);
 
  PROCEDURE MQODtoRAW(
      rawMQOD              IN OUT RAW,
      StrucId              IN CHAR,
      Version              IN BINARY_INTEGER,
      ObjectType           IN BINARY_INTEGER,
      ObjectName           IN CHAR,
      ObjectQMgrName       IN CHAR,
      DynamicQName         IN CHAR,
      AlternateUserId      IN CHAR,
      RecsPresent          IN BINARY_INTEGER,
      KnownDestCount       IN BINARY_INTEGER,
      UnknownDestCount     IN BINARY_INTEGER,
      InvalidDestCount     IN BINARY_INTEGER,
      ObjectRecOffset      IN BINARY_INTEGER,
      ResponseRecOffset    IN BINARY_INTEGER,
      ObjectRecPtr         IN BINARY_INTEGER,
      ResponseRecPtr       IN BINARY_INTEGER,
      AlternateSecurityId  IN RAW,
      ResolvedQName        IN CHAR,
      ResolvedQMgrName     IN CHAR
      ); 
  PROCEDURE MQODtoRAW(
      rawMQOD              IN OUT RAW,
      od                   IN     MQOD);
 
  PROCEDURE MQPMOtoRAW(
      rawMQPMO             IN OUT RAW,
      StrucId              IN CHAR,
      Version              IN BINARY_INTEGER,
      Options              IN BINARY_INTEGER,
      Timeout              IN BINARY_INTEGER,
      Contxt               IN BINARY_INTEGER,
      KnownDestCount       IN BINARY_INTEGER,
      UnknownDestCount     IN BINARY_INTEGER,
      InvalidDestCount     IN BINARY_INTEGER,
      ResolvedQName        IN CHAR,
      ResolvedQMgrName     IN CHAR,
      RecsPresent          IN BINARY_INTEGER,
      PutMsgRecFields      IN BINARY_INTEGER,
      PutMsgRecOffset      IN BINARY_INTEGER,
      ResponseRecOffset    IN BINARY_INTEGER,
      PutMsgRecPtr         IN BINARY_INTEGER,
      ResponseRecPtr       IN BINARY_INTEGER
      ); 
  PROCEDURE MQPMOtoRAW(
      rawMQPMO             IN OUT RAW,
      pmo                  IN     MQPMO);
 
  PROCEDURE RAWtoMQBO(
      rawMQBO              IN     RAW,
      StrucId              IN OUT CHAR,
      Version              IN OUT BINARY_INTEGER,
      Options              IN OUT BINARY_INTEGER
      ); 
  PROCEDURE RAWtoMQBO(
      rawMQBO              IN     RAW,
      bo                   IN OUT MQBO);
 
  PROCEDURE RAWtoMQCNO(
      rawMQCNO             IN     RAW,
      StrucId              IN OUT CHAR,
      Version              IN OUT BINARY_INTEGER,
      Options              IN OUT BINARY_INTEGER,
      ClientConnOffset     IN OUT BINARY_INTEGER,
      ClientConnPtr        IN OUT BINARY_INTEGER
      ); 
  PROCEDURE RAWtoMQCNO(
      rawMQCNO             IN     RAW,
      cno                  IN OUT MQCNO);
 
  PROCEDURE RAWtoMQGMO(
      rawMQGMO             IN     RAW,
      StrucId              IN OUT CHAR,
      Version              IN OUT BINARY_INTEGER,
      Options              IN OUT BINARY_INTEGER,
      WaitInterval         IN OUT BINARY_INTEGER,
      Signal1              IN OUT BINARY_INTEGER,
      Signal2              IN OUT BINARY_INTEGER,
      ResolvedQName        IN OUT CHAR,
      MatchOptions         IN OUT BINARY_INTEGER,
      GroupStatus          IN OUT CHAR,
      SegmentStatus        IN OUT CHAR,
      Segmentation         IN OUT CHAR,
      Reserved1            IN OUT CHAR,
      MsgToken             IN OUT RAW,
      ReturnedLength       IN OUT BINARY_INTEGER
      ); 
  PROCEDURE RAWtoMQGMO(
      rawMQGMO             IN     RAW,
      gmo                  IN OUT MQGMO);
 
  PROCEDURE RAWtoMQIIH(
      rawMQIIH             IN RAW,
      StrucId              IN OUT CHAR,
      Version              IN OUT BINARY_INTEGER,
      StrucLength          IN OUT BINARY_INTEGER,
      Encoding             IN OUT BINARY_INTEGER,
      CodedCharSetId       IN OUT BINARY_INTEGER,
      Format               IN OUT CHAR,
      Flags                IN OUT BINARY_INTEGER,
      LTermOverride        IN OUT CHAR,
      MFSMapName           IN OUT CHAR,
      ReplyToFormat        IN OUT CHAR,
      Authenticator        IN OUT CHAR,
      TranInstanceId       IN OUT RAW,
      TranState            IN OUT CHAR,
      CommitMode           IN OUT CHAR,
      SecurityScope        IN OUT CHAR,
      Reserved             IN OUT CHAR
      ); 
  PROCEDURE RAWtoMQIIH(
      rawMQIIH             IN     RAW,
      iih                  IN OUT MQIIH);
 
  PROCEDURE RAWtoMQMD(
      rawMQMD              IN     RAW,
      StrucId              IN OUT CHAR,
      Version              IN OUT BINARY_INTEGER,
      Report               IN OUT BINARY_INTEGER,
      MsgType              IN OUT BINARY_INTEGER,
      Expiry               IN OUT BINARY_INTEGER,
      Feedback             IN OUT BINARY_INTEGER,
      Encoding             IN OUT BINARY_INTEGER,
      CodedCharSetId       IN OUT BINARY_INTEGER,
      Format               IN OUT CHAR,
      Priority             IN OUT BINARY_INTEGER,
      Persistence          IN OUT BINARY_INTEGER,
      MsgId                IN OUT RAW,
      CorrelId             IN OUT RAW,
      BackoutCount         IN OUT BINARY_INTEGER,
      ReplyToQ             IN OUT CHAR,
      ReplyToQMgr          IN OUT CHAR,
      UserIdentifier       IN OUT CHAR,
      AccountingToken      IN OUT RAW,
      ApplIdentityData     IN OUT CHAR,
      PutApplType          IN OUT BINARY_INTEGER,
      putApplName          IN OUT CHAR,
      PutDate              IN OUT CHAR,
      PutTime              IN OUT CHAR,
      ApplOriginData       IN OUT CHAR,
      GroupId              IN OUT RAW,
      MsgSeqNumber         IN OUT BINARY_INTEGER,
      Offset               IN OUT BINARY_INTEGER,
      MsgFlags             IN OUT BINARY_INTEGER,
      OriginalLength       IN OUT BINARY_INTEGER
      ); 
  PROCEDURE RAWtoMQMD(
      rawMQMD              IN     RAW,
      md                   IN OUT MQMD);
 
  PROCEDURE RAWtoMQOD(
      rawMQOD              IN     RAW,
      StrucId              IN OUT CHAR,
      Version              IN OUT BINARY_INTEGER,
      ObjectType           IN OUT BINARY_INTEGER,
      ObjectName           IN OUT CHAR,
      ObjectQMgrName       IN OUT CHAR,
      DynamicQName         IN OUT CHAR,
      AlternateUserId      IN OUT CHAR,
      RecsPresent          IN OUT BINARY_INTEGER,
      KnownDestCount       IN OUT BINARY_INTEGER,
      UnknownDestCount     IN OUT BINARY_INTEGER,
      InvalidDestCount     IN OUT BINARY_INTEGER,
      ObjectRecOffset      IN OUT BINARY_INTEGER,
      ResponseRecOffset    IN OUT BINARY_INTEGER,
      ObjectRecPtr         IN OUT BINARY_INTEGER,
      ResponseRecPtr       IN OUT BINARY_INTEGER,
      AlternateSecurityId  IN OUT RAW,
      ResolvedQName        IN OUT CHAR,
      ResolvedQMgrName     IN OUT CHAR
      ); 
  PROCEDURE RAWtoMQOD(
      rawMQOD              IN     RAW,
      od                   IN OUT MQOD);
 
  PROCEDURE RAWtoMQPMO(
      rawMQPMO             IN     RAW,
      StrucId              IN OUT CHAR,
      Version              IN OUT BINARY_INTEGER,
      Options              IN OUT BINARY_INTEGER,
      Timeout              IN OUT BINARY_INTEGER,
      Contxt               IN OUT BINARY_INTEGER,
      KnownDestCount       IN OUT BINARY_INTEGER,
      UnknownDestCount     IN OUT BINARY_INTEGER,
      InvalidDestCount     IN OUT BINARY_INTEGER,
      ResolvedQName        IN OUT CHAR,
      ResolvedQMgrName     IN OUT CHAR,
      RecsPresent          IN OUT BINARY_INTEGER,
      PutMsgRecFields      IN OUT BINARY_INTEGER,
      PutMsgRecOffset      IN OUT BINARY_INTEGER,
      ResponseRecOffset    IN OUT BINARY_INTEGER,
      PutMsgRecPtr         IN OUT BINARY_INTEGER,
      ResponseRecPtr       IN OUT BINARY_INTEGER
      ); 
  PROCEDURE RAWtoMQPMO(
      rawMQPMO             IN     RAW,
      pmo                  IN OUT MQPMO);
 
end mqpack;
/
show errors;
 
CREATE OR REPLACE PACKAGE BODY mqpack IS
 
  /* External XA routines */
  FUNCTION xasqlpc(dbname          IN CHAR,
                 procedure_name  IN CHAR,
                 parm1           IN BINARY_INTEGER)
  RETURN BINARY_INTEGER
  IS EXTERNAL
    NAME "xasql1"
    LIBRARY mqulib1
    PARAMETERS (
                dbname         BY REFERENCE,
                procedure_name BY REFERENCE,
                parm1          LONG);

  FUNCTION xasqlpc(dbname          IN CHAR,
                 procedure_name  IN CHAR,
                 parm1           IN VARCHAR)
  RETURN BINARY_INTEGER
  IS EXTERNAL
    NAME "xasql2"
    LIBRARY mqulib1
    PARAMETERS (
                dbname         BY REFERENCE,
                procedure_name BY REFERENCE,
                parm1          BY REFERENCE);
 
  /* External memory copy routines */
  PROCEDURE CHARtoRAW(outraw  IN OUT RAW,
                      rawpos  IN     BINARY_INTEGER,
                      rawlen  IN     BINARY_INTEGER,
                      inchar  IN     CHAR,
                      charpos IN     BINARY_INTEGER)
  IS EXTERNAL
    NAME "mcpy"
    LIBRARY mqulib
    PARAMETERS (outraw  BY REFERENCE,
                rawpos  LONG,
                rawlen  LONG,
                inchar  BY REFERENCE,
                charpos LONG,
                outraw  LENGTH);
 
  PROCEDURE RAWtoCHAR(outchar IN OUT CHAR,
                      charpos IN     BINARY_INTEGER,
                      charlen IN     BINARY_INTEGER,
                      inraw   IN     RAW,
                      rawpos  IN     BINARY_INTEGER)
  IS EXTERNAL
    NAME "mcpy"
    LIBRARY mqulib
    PARAMETERS (outchar  BY REFERENCE,
                charpos  LONG,
                charlen  LONG,
                inraw    BY REFERENCE,
                rawpos   LONG);
 
  PROCEDURE RAWtoRAW(outraw    IN OUT RAW,
                      raw1pos  IN     BINARY_INTEGER,
                      raw1len  IN     BINARY_INTEGER,
                      inraw    IN     RAW,
                      raw2pos  IN     BINARY_INTEGER)
  IS EXTERNAL
    NAME "mcpy"
    LIBRARY mqulib
    PARAMETERS (outraw   BY REFERENCE,
                raw1pos  LONG,
                raw1len  LONG,
                inraw    BY REFERENCE,
                raw2pos  LONG,
                outraw   LENGTH,
                inraw    LENGTH);
 
  PROCEDURE RAWtoVARCHAR(outvc    IN OUT VARCHAR,
                      vcpos    IN     BINARY_INTEGER,
                      vclen    IN     BINARY_INTEGER,
                      inraw    IN     RAW,
                      rawpos   IN     BINARY_INTEGER)
  IS EXTERNAL
    NAME "mcpy"
    LIBRARY mqulib
    PARAMETERS (outvc    BY REFERENCE,
                vcpos    LONG,
                vclen    LONG,
                inraw    BY REFERENCE,
                rawpos   LONG,
                outvc    LENGTH,
                inraw    LENGTH);

  PROCEDURE VARCHARtoRAW(outraw   IN OUT RAW,
                      rawpos   IN     BINARY_INTEGER,
                      rawlen   IN     BINARY_INTEGER,
                      invc     IN     VARCHAR,
                      vcpos    IN     BINARY_INTEGER)
  IS EXTERNAL
    NAME "mcpy"
    LIBRARY mqulib
    PARAMETERS (outraw   BY REFERENCE,
                rawpos   LONG,
                rawlen   LONG,
                invc     BY REFERENCE,
                vcpos    LONG,
                outraw   LENGTH,
                invc     LENGTH);

  /* External MQSeries routines */
 
  PROCEDURE MQBEGIN(Hconn       IN     BINARY_INTEGER,
                   bo      IN OUT RAW,
                   CompCode   OUT BINARY_INTEGER,
                   Reason     OUT BINARY_INTEGER)
     IS EXTERNAL
       NAME "MQBEGIN"
       LIBRARY mqslib
       PARAMETERS (Hconn LONG,
                   bo BY REFERENCE,
                   CompCode LONG,
                   Reason LONG,
                   bo LENGTH);
 
  PROCEDURE MQCONN(QMgrName IN CHAR,
                   Hconn OUT BINARY_INTEGER,
                   CompCode OUT BINARY_INTEGER,
                   Reason OUT BINARY_INTEGER)
     IS EXTERNAL
       NAME "MQCONN"
       LIBRARY mqslib
       PARAMETERS (QMgrName BY REFERENCE,
                   Hconn LONG,
                   CompCode LONG,
                   Reason LONG);
 
  PROCEDURE MQCONNX(QMgrName IN CHAR,
                   cno IN OUT RAW,
                   Hconn OUT BINARY_INTEGER,
                   CompCode OUT BINARY_INTEGER,
                   Reason OUT BINARY_INTEGER)
     IS EXTERNAL
       NAME "MQCONNX"
       LIBRARY mqslib
       PARAMETERS (QMgrName BY REFERENCE,
                   cno BY REFERENCE,
                   Hconn LONG,
                   CompCode LONG,
                   Reason LONG,
                   cno LENGTH);
 
  PROCEDURE MQOPEN(Hconn        IN     BINARY_INTEGER,
                       od       IN OUT RAW,
                       Options  IN     BINARY_INTEGER,
                       Hobj     OUT    BINARY_INTEGER,
                       CompCode OUT    BINARY_INTEGER,
                       Reason   OUT    BINARY_INTEGER)
     IS EXTERNAL
       NAME "MQOPEN"
       LIBRARY mqslib
       PARAMETERS (Hconn LONG,
                   od BY REFERENCE,
                   Options LONG,
                   Hobj LONG,
                   CompCode LONG,
                   Reason LONG,
                   od LENGTH);
 
  PROCEDURE MQGET(Hconn        IN     BINARY_INTEGER,
                  Hobj     IN     BINARY_INTEGER,
                  md       IN OUT RAW,
                  gmo      IN OUT RAW,
                  len      IN     BINARY_INTEGER,
                  buff     IN OUT RAW,
                  mlen        OUT BINARY_INTEGER,
                  CompCode    OUT BINARY_INTEGER,
                  Reason      OUT BINARY_INTEGER)
     IS EXTERNAL
       NAME "MQGET"
       LIBRARY mqslib
       PARAMETERS (Hconn LONG,
                   Hobj LONG,
                   md BY REFERENCE,
                   gmo BY REFERENCE,
                   len LONG,
                   buff BY REFERENCE,
                   mlen LONG,
                   CompCode LONG,
                   Reason LONG,
                   md LENGTH,
                   gmo LENGTH,
                   buff LENGTH);
 
  PROCEDURE MQPUT(Hconn        IN     BINARY_INTEGER,
                  Hobj     IN     BINARY_INTEGER,
                  md       IN OUT RAW,
                  pmo      IN OUT RAW,
                  len      IN     BINARY_INTEGER,
                  buff     IN OUT RAW,
                  CompCode    OUT BINARY_INTEGER,
                  Reason      OUT BINARY_INTEGER)
     IS EXTERNAL
       NAME "MQPUT"
       LIBRARY mqslib
       PARAMETERS (Hconn LONG,
                   Hobj LONG,
                   md BY REFERENCE,
                   pmo BY REFERENCE,
                   len LONG,
                   buff BY REFERENCE,
                   CompCode LONG,
                   Reason LONG,
                   md LENGTH,
                   pmo LENGTH,
                   buff LENGTH);
 
  PROCEDURE MQPUT1(Hconn        IN     BINARY_INTEGER,
                  od       IN OUT RAW,
                  md       IN OUT RAW,
                  pmo      IN OUT RAW,
                  len      IN     BINARY_INTEGER,
                  buff     IN OUT RAW,
                  CompCode    OUT BINARY_INTEGER,
                  Reason      OUT BINARY_INTEGER)
     IS EXTERNAL
       NAME "MQPUT1"
       LIBRARY mqslib
       PARAMETERS (Hconn LONG,
                   od BY REFERENCE,
                   md BY REFERENCE,
                   pmo BY REFERENCE,
                   len LONG,
                   buff BY REFERENCE,
                   CompCode LONG,
                   Reason LONG,
                   od LENGTH,
                   md LENGTH,
                   pmo LENGTH,
                   buff LENGTH);
 
  PROCEDURE MQCLOSE(Hconn  IN     BINARY_INTEGER,
                  Hobj     IN     BINARY_INTEGER,
                  Options  IN     BINARY_INTEGER,
                  CompCode    OUT BINARY_INTEGER,
                  Reason      OUT BINARY_INTEGER)
     IS EXTERNAL
       NAME "MQCLOSE"
       LIBRARY mqslib
       PARAMETERS (Hconn LONG,
                   Hobj BY REFERENCE LONG,
                   Options LONG,
                   CompCode LONG,
                   Reason LONG);
 
  PROCEDURE MQDISC(Hconn  IN      BINARY_INTEGER,
                  CompCode    OUT BINARY_INTEGER,
                  Reason      OUT BINARY_INTEGER)
     IS EXTERNAL
       NAME "MQDISC"
       LIBRARY mqslib
       PARAMETERS (Hconn BY REFERENCE LONG,
                   CompCode LONG,
                   Reason LONG);
 
  PROCEDURE MQBACK(Hconn  IN      BINARY_INTEGER,
                  CompCode    OUT BINARY_INTEGER,
                  Reason      OUT BINARY_INTEGER)
     IS EXTERNAL
       NAME "MQBACK"
       LIBRARY mqslib
       PARAMETERS (Hconn LONG,
                   CompCode LONG,
                   Reason LONG);
 
  PROCEDURE MQCMIT(Hconn  IN      BINARY_INTEGER,
                  CompCode    OUT BINARY_INTEGER,
                  Reason      OUT BINARY_INTEGER)
     IS EXTERNAL
       NAME "MQCMIT"
       LIBRARY mqslib
       PARAMETERS (Hconn LONG,
                   CompCode LONG,
                   Reason LONG);
 
  /* Internal XA routines */

  FUNCTION xasec(dbname          IN CHAR,
                 procedure_name  IN CHAR)
    RETURN BINARY_INTEGER
    IS
       i          binary_integer;
       rc         int;
       userlen    binary_integer;
       username   varchar(50);
       using_list varchar(500);
       sql_stmt   varchar(500);
    BEGIN
       username := '*';
       userlen := LENGTH(USER);
       for i in 0..userlen loop
          select count(*) into rc from mqseries.mqxasecurity
           where (db_name = dbname OR db_name = '*')
             and (proc_name = procedure_name OR proc_name = '*')
             and user_name = username;
          if rc > 0 then
             return(0);
          end if;
          if i >= (userlen - 1) then
             username := USER;
          else
             username := substr(USER,1,i+1)||'*';
          end if;
       end loop;
       return (-1);
    END xasec;

  FUNCTION xasql(dbname          IN CHAR,
                 procedure_name  IN CHAR,
                 parm1           IN BINARY_INTEGER)
    RETURN BINARY_INTEGER
    IS
       rc    binary_integer;
    BEGIN
       rc := mqpack.xasec(dbname, procedure_name);
       if rc = 0 then
          rc := mqpack.xasqlpc(dbname, procedure_name, parm1);
       end if;
       return (rc);
    END xasql;

  FUNCTION xasql(dbname          IN CHAR,
                 procedure_name  IN CHAR,
                 parm1           IN VARCHAR)
    RETURN BINARY_INTEGER
    IS
       rc    binary_integer;
    BEGIN
       rc := mqpack.xasec(dbname, procedure_name);
       if rc = 0 then
          rc := mqpack.xasqlpc(dbname, procedure_name, parm1);
       end if;
       return (rc);
    END xasql;

  /* Internal PLSQL MQSeries routines */
 
  PROCEDURE MQBEGIN(Hconn   IN     BINARY_INTEGER,
                   bo      IN OUT MQBO,
                   CompCode   OUT BINARY_INTEGER,
                   Reason     OUT BINARY_INTEGER)
     IS
        rawbo     RAW(12);
     BEGIN
        rawbo := RPAD('0',23,'0');
        MQBOtoRAW(rawbo,
                 bo);
        MQBEGIN(Hconn,
                 rawbo,
                 CompCode,
                 Reason);
        RAWtoMQBO(rawbo,
                 bo);
  END MQBEGIN;
 
  PROCEDURE MQCONNX(QMgrName IN     CHAR,
                   cno      IN OUT MQCNO,
                   Hconn       OUT BINARY_INTEGER,
                   CompCode    OUT BINARY_INTEGER,
                   Reason      OUT BINARY_INTEGER)
     IS
        rawcno     RAW(20);
     BEGIN
        rawcno := RPAD('0',39,'0');
        MQCNOtoRAW(rawcno,
                 cno);
        MQCONNX(QMgrName,
                 rawcno,
                 Hconn,
                 CompCode,
                 Reason);
        RAWtoMQCNO(rawcno,
                 cno);
  END MQCONNX;
 
  PROCEDURE MQOPEN(Hconn IN BINARY_INTEGER,
                   od IN OUT MQOD,
                   Options IN BINARY_INTEGER,
                   Hobj OUT BINARY_INTEGER,
                   CompCode OUT BINARY_INTEGER,
                   Reason OUT BINARY_INTEGER)
     IS
        rawod     RAW(336);
     BEGIN
        rawod := RPAD('0',671,'0');
        MQODtoRAW(rawod,
                 od);
        MQOPEN(Hconn,
               rawod,
               Options,
               Hobj,
               CompCode,
               Reason);
        RAWtoMQOD(rawod,
                 od);
  END MQOPEN;
 
  PROCEDURE MQGET(Hconn    IN     BINARY_INTEGER,
                  Hobj     IN     BINARY_INTEGER,
                  md       IN OUT MQMD,
                  gmo      IN OUT MQGMO,
                  len      IN     BINARY_INTEGER,
                  buff     IN OUT RAW,
                  mlen        OUT BINARY_INTEGER,
                  CompCode    OUT BINARY_INTEGER,
                  Reason      OUT BINARY_INTEGER)
     IS
        rawmd     RAW(364);
        rawgmo    RAW(100);
     BEGIN
        rawmd := RPAD('0',727,'0');
        rawgmo := RPAD('0',199,'0');
        MQMDtoRAW(rawmd,
                  md);
        MQGMOtoRAW(rawgmo,
                   gmo);
        MQGET(Hconn,
                  Hobj,
                  rawmd,
                  rawgmo,
                  len,
                  buff,
                  mlen,
                  CompCode,
                  Reason);
        RAWtoMQMD(rawmd,
                  md);
        RAWtoMQGMO(rawgmo,
                   gmo);
  END MQGET;
 
  PROCEDURE MQPUT(Hconn    IN     BINARY_INTEGER,
                  Hobj     IN     BINARY_INTEGER,
                  md       IN OUT MQMD,
                  pmo      IN OUT MQPMO,
                  len      IN     BINARY_INTEGER,
                  buff     IN OUT RAW,
                  CompCode    OUT BINARY_INTEGER,
                  Reason      OUT BINARY_INTEGER)
     IS
        rawmd     RAW(364);
        rawpmo    RAW(152);
     BEGIN
        rawmd := RPAD('0',727,'0');
        rawpmo := RPAD('0',303,'0');
        MQMDtoRAW(rawmd,
                  md);
        MQPMOtoRAW(rawpmo,
                   pmo);
        MQPUT(Hconn,
                  Hobj,
                  rawmd,
                  rawpmo,
                  len,
                  buff,
                  CompCode,
                  Reason);
        RAWtoMQMD(rawmd,
                  md);
        RAWtoMQPMO(rawpmo,
                   pmo);
  END MQPUT;
 
  PROCEDURE MQPUT1(Hconn    IN     BINARY_INTEGER,
                  od       IN OUT MQOD,
                  md       IN OUT MQMD,
                  pmo      IN OUT MQPMO,
                  len      IN     BINARY_INTEGER,
                  buff     IN OUT RAW,
                  CompCode    OUT BINARY_INTEGER,
                  Reason      OUT BINARY_INTEGER)
     IS
        rawod     RAW(336);
        rawmd     RAW(364);
        rawpmo    RAW(152);
     BEGIN
        rawod := RPAD('0',671,'0');
        rawmd := RPAD('0',727,'0');
        rawpmo := RPAD('0',303,'0');
        MQODtoRAW(rawod,
                 od);
        MQMDtoRAW(rawmd,
                  md);
        MQPMOtoRAW(rawpmo,
                   pmo);
        MQPUT1(Hconn,
                  rawod,
                  rawmd,
                  rawpmo,
                  len,
                  buff,
                  CompCode,
                  Reason);
        RAWtoMQMD(rawmd,
                  md);
        RAWtoMQPMO(rawpmo,
                   pmo);
        RAWtoMQOD(rawod,
                 od);
  END MQPUT1;
 
  /* MQSeries structure to PLSQL RAW conversion routines */
 
  PROCEDURE MQBOtoRAW(
      rawMQBO              IN OUT RAW,
      StrucId              IN CHAR,
      Version              IN BINARY_INTEGER,
      Options              IN BINARY_INTEGER
      )
    IS EXTERNAL
      NAME "MQBOtoRAW"
      LIBRARY mqulib
      PARAMETERS(rawMQBO              BY REFERENCE RAW,
                 rawMQBO              LENGTH,
                 StrucId              BY REFERENCE,
                 Version              BY REFERENCE LONG,
                 Options              BY REFERENCE LONG
                 );
 
  PROCEDURE MQBOtoRAW(
      rawMQBO              IN OUT RAW,
      bo                   IN     MQBO)
    IS
    BEGIN
       MQBOtoRAW(rawMQBO,
                bo.StrucId,
                bo.Version,
                bo.Options);
  END MQBOtoRAW;
 
  PROCEDURE MQCNOtoRAW(
      rawMQCNO             IN OUT RAW,
      StrucId              IN CHAR,
      Version              IN BINARY_INTEGER,
      Options              IN BINARY_INTEGER,
      ClientConnOffset     IN BINARY_INTEGER,
      ClientConnPtr        IN BINARY_INTEGER
      )
    IS EXTERNAL
      NAME "MQCNOtoRAW"
      LIBRARY mqulib
      PARAMETERS(rawMQCNO             BY REFERENCE RAW,
                 rawMQCNO             LENGTH,
                 StrucId              BY REFERENCE,
                 Version              BY REFERENCE LONG,
                 Options              BY REFERENCE LONG,
                 ClientConnOffset     BY REFERENCE LONG,
                 ClientConnPtr        BY REFERENCE LONG
                 );
 
  PROCEDURE MQCNOtoRAW(
      rawMQCNO             IN OUT RAW,
      cno                  IN     MQCNO)
    IS
    BEGIN
        MQCNOtoRAW(rawMQCNO,
                 cno.StrucId,
                 cno.Version,
                 cno.Options,
                 cno.ClientConnOffset,
                 cno.ClientConnPtr);
  END MQCNOtoRAW;
 
  PROCEDURE MQGMOtoRAW(
      rawMQGMO             IN OUT RAW,
      StrucId              IN CHAR,
      Version              IN BINARY_INTEGER,
      Options              IN BINARY_INTEGER,
      WaitInterval         IN BINARY_INTEGER,
      Signal1              IN BINARY_INTEGER,
      Signal2              IN BINARY_INTEGER,
      ResolvedQName        IN CHAR,
      MatchOptions         IN BINARY_INTEGER,
      GroupStatus          IN CHAR,
      SegmentStatus        IN CHAR,
      Segmentation         IN CHAR,
      Reserved1            IN CHAR,
      MsgToken             IN RAW,
      ReturnedLength       IN BINARY_INTEGER
      )
    IS EXTERNAL
      NAME "MQGMOtoRAW"
      LIBRARY mqulib
      PARAMETERS(rawMQGMO             BY REFERENCE RAW,
                 rawMQGMO             LENGTH,
                 StrucId              BY REFERENCE,
                 Version              BY REFERENCE LONG,
                 Options              BY REFERENCE LONG,
                 WaitInterval         BY REFERENCE LONG,
                 Signal1              BY REFERENCE LONG,
                 Signal2              BY REFERENCE LONG,
                 ResolvedQName        BY REFERENCE,
                 MatchOptions         BY REFERENCE LONG,
                 GroupStatus          BY REFERENCE,
                 SegmentStatus        BY REFERENCE,
                 Segmentation         BY REFERENCE,
                 Reserved1            BY REFERENCE,
                 MsgToken             BY REFERENCE,
                 ReturnedLength       BY REFERENCE LONG
                 );
 
  PROCEDURE MQGMOtoRAW(
      rawMQGMO             IN OUT RAW,
      gmo                  IN     MQGMO)
    IS
    BEGIN
        MQGMOtoRAW(rawMQGMO,
                   gmo.StrucId,
                   gmo.Version,
                   gmo.Options,
                   gmo.WaitInterval,
                   gmo.Signal1,
                   gmo.Signal2,
                   gmo.ResolvedQName,
                   gmo.MatchOptions,
                   gmo.GroupStatus,
                   gmo.SegmentStatus,
                   gmo.Segmentation,
                   gmo.Reserved1,
                   gmo.MsgToken,
                   gmo.ReturnedLength);
  END MQGMOtoRAW;
 
  PROCEDURE MQIIHtoRAW(
      rawMQIIH             IN OUT RAW,
      StrucId              IN CHAR,
      Version              IN BINARY_INTEGER,
      StrucLength          IN BINARY_INTEGER,
      Encoding             IN BINARY_INTEGER,
      CodedCharSetId       IN BINARY_INTEGER,
      Format               IN CHAR,
      Flags                IN BINARY_INTEGER,
      LTermOverride        IN CHAR,
      MFSMapName           IN CHAR,
      ReplyToFormat        IN CHAR,
      Authenticator        IN CHAR,
      TranInstanceId       IN RAW,
      TranState            IN CHAR,
      CommitMode           IN CHAR,
      SecurityScope        IN CHAR,
      Reserved             IN CHAR
      )
    IS EXTERNAL
      NAME "MQIIHtoRAW"
      LIBRARY mqulib
      PARAMETERS(rawMQIIH             BY REFERENCE RAW,
                 rawMQIIH             LENGTH,
                 StrucId              BY REFERENCE,
                 Version              BY REFERENCE LONG,
                 StrucLength          BY REFERENCE LONG,
                 Encoding             BY REFERENCE LONG,
                 CodedCharSetId       BY REFERENCE LONG,
                 Format               BY REFERENCE,
                 Flags                BY REFERENCE LONG,
                 LTermOverride        BY REFERENCE,
                 MFSMapName           BY REFERENCE,
                 ReplyToFormat        BY REFERENCE,
                 Authenticator        BY REFERENCE,
                 TranInstanceId       BY REFERENCE,
                 TranState            BY REFERENCE,
                 CommitMode           BY REFERENCE,
                 SecurityScope        BY REFERENCE,
                 Reserved             BY REFERENCE
                 );
 
  PROCEDURE MQIIHtoRAW(
      rawMQIIH             IN OUT RAW,
      iih                  IN     MQIIH)
  IS
  BEGIN
 
      MQIIHtoRAW(
          rawMQIIH,
          iih.StrucId,
          iih.Version,
          iih.StrucLength,
          iih.Encoding,
          iih.CodedCharSetId,
          iih.Format,
          iih.Flags,
          iih.LTermOverride,
          iih.MFSMapName,
          iih.ReplyToFormat,
          iih.Authenticator,
          iih.TranInstanceId,
          iih.TranState,
          iih.CommitMode,
          iih.SecurityScope,
          iih.Reserved);
 
  END MQIIHtoRAW;
 
  PROCEDURE MQMDtoRAW(
      rawMQMD              IN OUT RAW,
      StrucId              IN CHAR,
      Version              IN BINARY_INTEGER,
      Report               IN BINARY_INTEGER,
      MsgType              IN BINARY_INTEGER,
      Expiry               IN BINARY_INTEGER,
      Feedback             IN BINARY_INTEGER,
      Encoding             IN BINARY_INTEGER,
      CodedCharSetId       IN BINARY_INTEGER,
      Format               IN CHAR,
      Priority             IN BINARY_INTEGER,
      Persistence          IN BINARY_INTEGER,
      MsgId                IN RAW,
      CorrelId             IN RAW,
      BackoutCount         IN BINARY_INTEGER,
      ReplyToQ             IN CHAR,
      ReplyToQMgr          IN CHAR,
      UserIdentifier       IN CHAR,
      AccountingToken      IN RAW,
      ApplIdentityData     IN CHAR,
      PutApplType          IN BINARY_INTEGER,
      PutApplName          IN CHAR,
      PutDate              IN CHAR,
      PutTime              IN CHAR,
      ApplOriginData       IN CHAR,
      GroupId              IN RAW,
      MsgSeqNumber         IN BINARY_INTEGER,
      Offset               IN BINARY_INTEGER,
      MsgFlags             IN BINARY_INTEGER,
      OriginalLength       IN BINARY_INTEGER
      )
    IS EXTERNAL
      NAME "MQMDtoRAW"
      LIBRARY mqulib
      PARAMETERS(rawMQMD              BY REFERENCE RAW,
                 rawMQMD              LENGTH,
                 StrucId              BY REFERENCE,
                 Version              BY REFERENCE LONG,
                 Report               BY REFERENCE LONG,
                 MsgType              BY REFERENCE LONG,
                 Expiry               BY REFERENCE LONG,
                 Feedback             BY REFERENCE LONG,
                 Encoding             BY REFERENCE LONG,
                 CodedCharSetId       BY REFERENCE LONG,
                 Format               BY REFERENCE,
                 Priority             BY REFERENCE LONG,
                 Persistence          BY REFERENCE LONG,
                 MsgId                BY REFERENCE,
                 CorrelId             BY REFERENCE,
                 BackoutCount         BY REFERENCE LONG,
                 ReplyToQ             BY REFERENCE,
                 ReplyToQMgr          BY REFERENCE,
                 UserIdentifier       BY REFERENCE,
                 AccountingToken      BY REFERENCE,
                 ApplIdentityData     BY REFERENCE,
                 PutApplType          BY REFERENCE LONG,
                 PutApplName          BY REFERENCE,
                 PutDate              BY REFERENCE,
                 PutTime              BY REFERENCE,
                 ApplOriginData       BY REFERENCE,
                 GroupId              BY REFERENCE,
                 MsgSeqNumber         BY REFERENCE LONG,
                 Offset               BY REFERENCE LONG,
                 MsgFlags             BY REFERENCE LONG,
                 OriginalLength       BY REFERENCE LONG
                 );
 
  PROCEDURE MQMDtoRAW(
      rawMQMD              IN OUT RAW,
      md                   IN     MQMD)
    IS
    BEGIN
        MQMDtoRAW(rawMQMD,
                  md.StrucId,
                  md.Version,
                  md.Report,
                  md.MsgType,
                  md.Expiry,
                  md.Feedback,
                  md.Encoding,
                  md.CodedCharSetId,
                  md.Format,
                  md.Priority,
                  md.Persistence,
                  md.MsgId,
                  md.CorrelId,
                  md.BackoutCount,
                  md.ReplyToQ,
                  md.ReplyToQMgr,
                  md.UserIdentifier,
                  md.AccountingToken,
                  md.ApplIdentityData,
                  md.PutApplType,
                  md.PutApplName,
                  md.PutDate,
                  md.PutTime,
                  md.ApplOriginData,
                  md.GroupId,
                  md.MsgSeqNumber,
                  md.Offset,
                  md.MsgFlags,
                  md.OriginalLength);
  END MQMDtoRAW;
 
  PROCEDURE MQODtoRAW(
      rawMQOD              IN OUT RAW,
      StrucId              IN CHAR,
      Version              IN BINARY_INTEGER,
      ObjectType           IN BINARY_INTEGER,
      ObjectName           IN CHAR,
      ObjectQMgrName       IN CHAR,
      DynamicQName         IN CHAR,
      AlternateUserId      IN CHAR,
      RecsPresent          IN BINARY_INTEGER,
      KnownDestCount       IN BINARY_INTEGER,
      UnknownDestCount     IN BINARY_INTEGER,
      InvalidDestCount     IN BINARY_INTEGER,
      ObjectRecOffset      IN BINARY_INTEGER,
      ResponseRecOffset    IN BINARY_INTEGER,
      ObjectRecPtr         IN BINARY_INTEGER,
      ResponseRecPtr       IN BINARY_INTEGER,
      AlternateSecurityId  IN RAW,
      ResolvedQName        IN CHAR,
      ResolvedQMgrName     IN CHAR
      )
    IS EXTERNAL
      NAME "MQODtoRAW"
      LIBRARY mqulib
      PARAMETERS(rawMQOD              BY REFERENCE RAW,
                 rawMQOD              LENGTH,
                 StrucId              BY REFERENCE,
                 Version              BY REFERENCE LONG,
                 ObjectType           BY REFERENCE LONG,
                 ObjectName           BY REFERENCE,
                 ObjectQMgrName       BY REFERENCE,
                 DynamicQName         BY REFERENCE,
                 AlternateUserId      BY REFERENCE,
                 RecsPresent          BY REFERENCE LONG,
                 KnownDestCount       BY REFERENCE LONG,
                 UnknownDestCount     BY REFERENCE LONG,
                 InvalidDestCount     BY REFERENCE LONG,
                 ObjectRecOffset      BY REFERENCE LONG,
                 ResponseRecOffset    BY REFERENCE LONG,
                 ObjectRecPtr         BY REFERENCE LONG,
                 ResponseRecPtr       BY REFERENCE LONG,
                 AlternateSecurityId  BY REFERENCE,
                 ResolvedQName        BY REFERENCE,
                 ResolvedQMgrName     BY REFERENCE
                 );
 
  PROCEDURE MQODtoRAW(
      rawMQOD              IN OUT RAW,
      od                   IN     MQOD)
    IS
    BEGIN
        MQODtoRAW(rawMQOD,
                 od.StrucId,
                 od.Version,
                 od.ObjectType,
                 od.ObjectName,
                 od.ObjectQMgrName,
                 od.DynamicQName,
                 od.AlternateUserId,
                 od.RecsPresent,
                 od.KnownDestCount,
                 od.UnknownDestCount,
                 od.InvalidDestCount,
                 od.ObjectRecOffset,
                 od.ResponseRecOffset,
                 od.ObjectRecPtr,
                 od.ResponseRecPtr,
                 od.AlternateSecurityId,
                 od.ResolvedQName,
                 od.ResolvedQMgrName);
  END MQODtoRAW;
 
  PROCEDURE MQPMOtoRAW(
      rawMQPMO             IN OUT RAW,
      StrucId              IN CHAR,
      Version              IN BINARY_INTEGER,
      Options              IN BINARY_INTEGER,
      Timeout              IN BINARY_INTEGER,
      Contxt               IN BINARY_INTEGER,
      KnownDestCount       IN BINARY_INTEGER,
      UnknownDestCount     IN BINARY_INTEGER,
      InvalidDestCount     IN BINARY_INTEGER,
      ResolvedQName        IN CHAR,
      ResolvedQMgrName     IN CHAR,
      RecsPresent          IN BINARY_INTEGER,
      PutMsgRecFields      IN BINARY_INTEGER,
      PutMsgRecOffset      IN BINARY_INTEGER,
      ResponseRecOffset    IN BINARY_INTEGER,
      PutMsgRecPtr         IN BINARY_INTEGER,
      ResponseRecPtr       IN BINARY_INTEGER
      )
    IS EXTERNAL
      NAME "MQPMOtoRAW"
      LIBRARY mqulib
      PARAMETERS(rawMQPMO             BY REFERENCE RAW,
                 rawMQPMO             LENGTH,
                 StrucId              BY REFERENCE,
                 Version              BY REFERENCE LONG,
                 Options              BY REFERENCE LONG,
                 Timeout              BY REFERENCE LONG,
                 Contxt               BY REFERENCE LONG,
                 KnownDestCount       BY REFERENCE LONG,
                 UnknownDestCount     BY REFERENCE LONG,
                 InvalidDestCount     BY REFERENCE LONG,
                 ResolvedQName        BY REFERENCE,
                 ResolvedQMgrName     BY REFERENCE,
                 RecsPresent          BY REFERENCE LONG,
                 PutMsgRecFields      BY REFERENCE LONG,
                 PutMsgRecOffset      BY REFERENCE LONG,
                 ResponseRecOffset    BY REFERENCE LONG,
                 PutMsgRecPtr         BY REFERENCE LONG,
                 ResponseRecPtr       BY REFERENCE LONG
                 );
 
  PROCEDURE MQPMOtoRAW(
      rawMQPMO             IN OUT RAW,
      pmo                  IN     MQPMO)
    IS
    BEGIN
        MQPMOtoRAW(rawMQPMO,
                   pmo.StrucId,
                   pmo.Version,
                   pmo.Options,
                   pmo.Timeout,
                   pmo.Context,
                   pmo.KnownDestCount,
                   pmo.UnknownDestCount,
                   pmo.InvalidDestCount,
                   pmo.ResolvedQName,
                   pmo.ResolvedQMgrName,
                   pmo.RecsPresent,
                   pmo.PutMsgRecFields,
                   pmo.PutMsgRecOffset,
                   pmo.ResponseRecOffset,
                   pmo.PutMsgRecPtr,
                   pmo.ResponseRecPtr);
  END MQPMOtoRAW;
 
  PROCEDURE RAWtoMQBO(
      rawMQBO              IN RAW,
      StrucId              IN OUT CHAR,
      Version              IN OUT BINARY_INTEGER,
      Options              IN OUT BINARY_INTEGER
      )
    IS EXTERNAL
      NAME "RAWtoMQBO"
      LIBRARY mqulib
      PARAMETERS(rawMQBO              BY REFERENCE RAW,
                 StrucId              BY REFERENCE,
                 Version              BY REFERENCE LONG,
                 Options              BY REFERENCE LONG
                 );
 
  PROCEDURE RAWtoMQBO(
      rawMQBO              IN     RAW,
      bo                   IN OUT MQBO)
    IS
    BEGIN
       RAWtoMQBO(rawMQBO,
                bo.StrucId,
                bo.Version,
                bo.Options);
  END RAWtoMQBO;
 
  PROCEDURE RAWtoMQCNO(
      rawMQCNO             IN RAW,
      StrucId              IN OUT CHAR,
      Version              IN OUT BINARY_INTEGER,
      Options              IN OUT BINARY_INTEGER,
      ClientConnOffset     IN OUT BINARY_INTEGER,
      ClientConnPtr        IN OUT BINARY_INTEGER
      )
    IS EXTERNAL
      NAME "RAWtoMQCNO"
      LIBRARY mqulib
      PARAMETERS(rawMQCNO             BY REFERENCE RAW,
                 StrucId              BY REFERENCE,
                 Version              BY REFERENCE LONG,
                 Options              BY REFERENCE LONG,
                 ClientConnOffset     BY REFERENCE LONG,
                 ClientConnPtr        BY REFERENCE LONG
                 );
 
  PROCEDURE RAWtoMQCNO(
      rawMQCNO             IN     RAW,
      cno                  IN OUT MQCNO)
    IS
    BEGIN
        RAWtoMQCNO(rawMQCNO,
                 cno.StrucId,
                 cno.Version,
                 cno.Options,
                 cno.ClientConnOffset,
                 cno.ClientConnPtr);
  END RAWtoMQCNO;
 
  PROCEDURE RAWtoMQGMO(
      rawMQGMO             IN RAW,
      StrucId              IN OUT CHAR,
      Version              IN OUT BINARY_INTEGER,
      Options              IN OUT BINARY_INTEGER,
      WaitInterval         IN OUT BINARY_INTEGER,
      Signal1              IN OUT BINARY_INTEGER,
      Signal2              IN OUT BINARY_INTEGER,
      ResolvedQName        IN OUT CHAR,
      MatchOptions         IN OUT BINARY_INTEGER,
      GroupStatus          IN OUT CHAR,
      SegmentStatus        IN OUT CHAR,
      Segmentation         IN OUT CHAR,
      Reserved1            IN OUT CHAR,
      MsgToken             IN OUT RAW,
      ReturnedLength       IN OUT BINARY_INTEGER
      )
    IS EXTERNAL
      NAME "RAWtoMQGMO"
      LIBRARY mqulib
      PARAMETERS(rawMQGMO             BY REFERENCE RAW,
                 StrucId              BY REFERENCE,
                 Version              BY REFERENCE LONG,
                 Options              BY REFERENCE LONG,
                 WaitInterval         BY REFERENCE LONG,
                 Signal1              BY REFERENCE LONG,
                 Signal2              BY REFERENCE LONG,
                 ResolvedQName        BY REFERENCE,
                 MatchOptions         BY REFERENCE LONG,
                 GroupStatus          BY REFERENCE,
                 SegmentStatus        BY REFERENCE,
                 Segmentation         BY REFERENCE,
                 Reserved1            BY REFERENCE,
                 MsgToken             BY REFERENCE,
                 MsgToken             LENGTH BY REFERENCE,
                 ReturnedLength       BY REFERENCE LONG
                 );
 
  PROCEDURE RAWtoMQGMO(
      rawMQGMO             IN     RAW,
      gmo                  IN OUT MQGMO)
    IS
    BEGIN
        RAWtoMQGMO(rawMQGMO,
                   gmo.StrucId,
                   gmo.Version,
                   gmo.Options,
                   gmo.WaitInterval,
                   gmo.Signal1,
                   gmo.Signal2,
                   gmo.ResolvedQName,
                   gmo.MatchOptions,
                   gmo.GroupStatus,
                   gmo.SegmentStatus,
                   gmo.Segmentation,
                   gmo.Reserved1,
                   gmo.MsgToken,
                   gmo.ReturnedLength);
  END RAWtoMQGMO;
 
  PROCEDURE RAWtoMQIIH(
      rawMQIIH             IN RAW,
      StrucId              IN OUT CHAR,
      Version              IN OUT BINARY_INTEGER,
      StrucLength          IN OUT BINARY_INTEGER,
      Encoding             IN OUT BINARY_INTEGER,
      CodedCharSetId       IN OUT BINARY_INTEGER,
      Format               IN OUT CHAR,
      Flags                IN OUT BINARY_INTEGER,
      LTermOverride        IN OUT CHAR,
      MFSMapName           IN OUT CHAR,
      ReplyToFormat        IN OUT CHAR,
      Authenticator        IN OUT CHAR,
      TranInstanceId       IN OUT RAW,
      TranState            IN OUT CHAR,
      CommitMode           IN OUT CHAR,
      SecurityScope        IN OUT CHAR,
      Reserved             IN OUT CHAR
      )
    IS EXTERNAL
      NAME "RAWtoMQIIH"
      LIBRARY mqulib
      PARAMETERS(rawMQIIH             BY REFERENCE RAW,
                 StrucId              BY REFERENCE,
                 Version              BY REFERENCE LONG,
                 StrucLength          BY REFERENCE LONG,
                 Encoding             BY REFERENCE LONG,
                 CodedCharSetId       BY REFERENCE LONG,
                 Format               BY REFERENCE,
                 Flags                BY REFERENCE LONG,
                 LTermOverride        BY REFERENCE,
                 MFSMapName           BY REFERENCE,
                 ReplyToFormat        BY REFERENCE,
                 Authenticator        BY REFERENCE,
                 TranInstanceId       BY REFERENCE,
                 TranInstanceId       LENGTH BY REFERENCE,
                 TranState            BY REFERENCE,
                 CommitMode           BY REFERENCE,
                 SecurityScope        BY REFERENCE,
                 Reserved             BY REFERENCE
                 );
 
  PROCEDURE RAWtoMQIIH(
      rawMQIIH             IN     RAW,
      iih                  IN OUT MQIIH)
  IS
 
  BEGIN
 
      RAWtoMQIIH(
          rawMQIIH,
          iih.StrucId,
          iih.Version,
          iih.StrucLength,
          iih.Encoding,
          iih.CodedCharSetId,
          iih.Format,
          iih.Flags,
          iih.LTermOverride,
          iih.MFSMapName,
          iih.ReplyToFormat,
          iih.Authenticator,
          iih.TranInstanceId,
          iih.TranState,
          iih.CommitMode,
          iih.SecurityScope,
          iih.Reserved);
 
  END RAWtoMQIIH;
 
  PROCEDURE RAWtoMQMD(
      rawMQMD              IN RAW,
      StrucId              IN OUT CHAR,
      Version              IN OUT BINARY_INTEGER,
      Report               IN OUT BINARY_INTEGER,
      MsgType              IN OUT BINARY_INTEGER,
      Expiry               IN OUT BINARY_INTEGER,
      Feedback             IN OUT BINARY_INTEGER,
      Encoding             IN OUT BINARY_INTEGER,
      CodedCharSetId       IN OUT BINARY_INTEGER,
      Format               IN OUT CHAR,
      Priority             IN OUT BINARY_INTEGER,
      Persistence          IN OUT BINARY_INTEGER,
      MsgId                IN OUT RAW,
      CorrelId             IN OUT RAW,
      BackoutCount         IN OUT BINARY_INTEGER,
      ReplyToQ             IN OUT CHAR,
      ReplyToQMgr          IN OUT CHAR,
      UserIdentifier       IN OUT CHAR,
      AccountingToken      IN OUT RAW,
      ApplIdentityData     IN OUT CHAR,
      PutApplType          IN OUT BINARY_INTEGER,
      PutApplName          IN OUT CHAR,
      PutDate              IN OUT CHAR,
      PutTime              IN OUT CHAR,
      ApplOriginData       IN OUT CHAR,
      GroupId              IN OUT RAW,
      MsgSeqNumber         IN OUT BINARY_INTEGER,
      Offset               IN OUT BINARY_INTEGER,
      MsgFlags             IN OUT BINARY_INTEGER,
      OriginalLength       IN OUT BINARY_INTEGER
      )
    IS EXTERNAL
      NAME "RAWtoMQMD"
      LIBRARY mqulib
      PARAMETERS(rawMQMD              BY REFERENCE RAW,
                 StrucId              BY REFERENCE,
                 Version              BY REFERENCE LONG,
                 Report               BY REFERENCE LONG,
                 MsgType              BY REFERENCE LONG,
                 Expiry               BY REFERENCE LONG,
                 Feedback             BY REFERENCE LONG,
                 Encoding             BY REFERENCE LONG,
                 CodedCharSetId       BY REFERENCE LONG,
                 Format               BY REFERENCE,
                 Priority             BY REFERENCE LONG,
                 Persistence          BY REFERENCE LONG,
                 MsgId                BY REFERENCE,
                 MsgId                LENGTH BY REFERENCE,
                 CorrelId             BY REFERENCE,
                 CorrelId             LENGTH BY REFERENCE,
                 BackoutCount         BY REFERENCE LONG,
                 ReplyToQ             BY REFERENCE,
                 ReplyToQMgr          BY REFERENCE,
                 UserIdentifier       BY REFERENCE,
                 AccountingToken      BY REFERENCE,
                 AccountingToken      LENGTH BY REFERENCE,
                 ApplIdentityData     BY REFERENCE,
                 PutApplType          BY REFERENCE LONG,
                 PutApplName          BY REFERENCE,
                 PutDate              BY REFERENCE,
                 PutTime              BY REFERENCE,
                 ApplOriginData       BY REFERENCE,
                 GroupId              BY REFERENCE,
                 GroupId              LENGTH BY REFERENCE,
                 MsgSeqNumber         BY REFERENCE LONG,
                 Offset               BY REFERENCE LONG,
                 MsgFlags             BY REFERENCE LONG,
                 OriginalLength       BY REFERENCE LONG
                 );
 
  PROCEDURE RAWtoMQMD(
      rawMQMD              IN     RAW,
      md                   IN OUT MQMD)
    IS
    BEGIN
        RAWtoMQMD(rawMQMD,
                  md.StrucId,
                  md.Version,
                  md.Report,
                  md.MsgType,
                  md.Expiry,
                  md.Feedback,
                  md.Encoding,
                  md.CodedCharSetId,
                  md.Format,
                  md.Priority,
                  md.Persistence,
                  md.MsgId,
                  md.CorrelId,
                  md.BackoutCount,
                  md.ReplyToQ,
                  md.ReplyToQMgr,
                  md.UserIdentifier,
                  md.AccountingToken,
                  md.ApplIdentityData,
                  md.PutApplType,
                  md.PutApplName,
                  md.PutDate,
                  md.PutTime,
                  md.ApplOriginData,
                  md.GroupId,
                  md.MsgSeqNumber,
                  md.Offset,
                  md.MsgFlags,
                  md.OriginalLength);
  END RAWtoMQMD;
 
  PROCEDURE RAWtoMQOD(
      rawMQOD              IN RAW,
      StrucId              IN OUT CHAR,
      Version              IN OUT BINARY_INTEGER,
      ObjectType           IN OUT BINARY_INTEGER,
      ObjectName           IN OUT CHAR,
      ObjectQMgrName       IN OUT CHAR,
      DynamicQName         IN OUT CHAR,
      AlternateUserId      IN OUT CHAR,
      RecsPresent          IN OUT BINARY_INTEGER,
      KnownDestCount       IN OUT BINARY_INTEGER,
      UnknownDestCount     IN OUT BINARY_INTEGER,
      InvalidDestCount     IN OUT BINARY_INTEGER,
      ObjectRecOffset      IN OUT BINARY_INTEGER,
      ResponseRecOffset    IN OUT BINARY_INTEGER,
      ObjectRecPtr         IN OUT BINARY_INTEGER,
      ResponseRecPtr       IN OUT BINARY_INTEGER,
      AlternateSecurityId  IN OUT RAW,
      ResolvedQName        IN OUT CHAR,
      ResolvedQMgrName     IN OUT CHAR
      )
    IS EXTERNAL
      NAME "RAWtoMQOD"
      LIBRARY mqulib
      PARAMETERS(rawMQOD              BY REFERENCE RAW,
                 StrucId              BY REFERENCE,
                 Version              BY REFERENCE LONG,
                 ObjectType           BY REFERENCE LONG,
                 ObjectName           BY REFERENCE,
                 ObjectQMgrName       BY REFERENCE,
                 DynamicQName         BY REFERENCE,
                 AlternateUserId      BY REFERENCE,
                 RecsPresent          BY REFERENCE LONG,
                 KnownDestCount       BY REFERENCE LONG,
                 UnknownDestCount     BY REFERENCE LONG,
                 InvalidDestCount     BY REFERENCE LONG,
                 ObjectRecOffset      BY REFERENCE LONG,
                 ResponseRecOffset    BY REFERENCE LONG,
                 ObjectRecPtr         BY REFERENCE LONG,
                 ResponseRecPtr       BY REFERENCE LONG,
                 AlternateSecurityId  BY REFERENCE,
                 AlternateSecurityId  LENGTH BY REFERENCE,
                 ResolvedQName        BY REFERENCE,
                 ResolvedQMgrName     BY REFERENCE
                 );
 
  PROCEDURE RAWtoMQOD(
      rawMQOD              IN     RAW,
      od                   IN OUT MQOD)
    IS
    BEGIN
        RAWtoMQOD(rawMQOD,
                 od.StrucId,
                 od.Version,
                 od.ObjectType,
                 od.ObjectName,
                 od.ObjectQMgrName,
                 od.DynamicQName,
                 od.AlternateUserId,
                 od.RecsPresent,
                 od.KnownDestCount,
                 od.UnknownDestCount,
                 od.InvalidDestCount,
                 od.ObjectRecOffset,
                 od.ResponseRecOffset,
                 od.ObjectRecPtr,
                 od.ResponseRecPtr,
                 od.AlternateSecurityId,
                 od.ResolvedQName,
                 od.ResolvedQMgrName);
  END RAWtoMQOD;
 
  PROCEDURE RAWtoMQPMO(
      rawMQPMO             IN RAW,
      StrucId              IN OUT CHAR,
      Version              IN OUT BINARY_INTEGER,
      Options              IN OUT BINARY_INTEGER,
      Timeout              IN OUT BINARY_INTEGER,
      Contxt               IN OUT BINARY_INTEGER,
      KnownDestCount       IN OUT BINARY_INTEGER,
      UnknownDestCount     IN OUT BINARY_INTEGER,
      InvalidDestCount     IN OUT BINARY_INTEGER,
      ResolvedQName        IN OUT CHAR,
      ResolvedQMgrName     IN OUT CHAR,
      RecsPresent          IN OUT BINARY_INTEGER,
      PutMsgRecFields      IN OUT BINARY_INTEGER,
      PutMsgRecOffset      IN OUT BINARY_INTEGER,
      ResponseRecOffset    IN OUT BINARY_INTEGER,
      PutMsgRecPtr         IN OUT BINARY_INTEGER,
      ResponseRecPtr       IN OUT BINARY_INTEGER
      )
    IS EXTERNAL
      NAME "RAWtoMQPMO"
      LIBRARY mqulib
      PARAMETERS(rawMQPMO             BY REFERENCE RAW,
                 StrucId              BY REFERENCE,
                 Version              BY REFERENCE LONG,
                 Options              BY REFERENCE LONG,
                 Timeout              BY REFERENCE LONG,
                 Contxt               BY REFERENCE LONG,
                 KnownDestCount       BY REFERENCE LONG,
                 UnknownDestCount     BY REFERENCE LONG,
                 InvalidDestCount     BY REFERENCE LONG,
                 ResolvedQName        BY REFERENCE,
                 ResolvedQMgrName     BY REFERENCE,
                 RecsPresent          BY REFERENCE LONG,
                 PutMsgRecFields      BY REFERENCE LONG,
                 PutMsgRecOffset      BY REFERENCE LONG,
                 ResponseRecOffset    BY REFERENCE LONG,
                 PutMsgRecPtr         BY REFERENCE LONG,
                 ResponseRecPtr       BY REFERENCE LONG
                 );
 
  PROCEDURE RAWtoMQPMO(
      rawMQPMO             IN     RAW,
      pmo                  IN OUT MQPMO)
    IS
    BEGIN
        RAWtoMQPMO(rawMQPMO,
                   pmo.StrucId,
                   pmo.Version,
                   pmo.Options,
                   pmo.Timeout,
                   pmo.Context,
                   pmo.KnownDestCount,
                   pmo.UnknownDestCount,
                   pmo.InvalidDestCount,
                   pmo.ResolvedQName,
                   pmo.ResolvedQMgrName,
                   pmo.RecsPresent,
                   pmo.PutMsgRecFields,
                   pmo.PutMsgRecOffset,
                   pmo.ResponseRecOffset,
                   pmo.PutMsgRecPtr,
                   pmo.ResponseRecPtr);
  END RAWtoMQPMO;
 
END mqpack;
/
 
show errors
 
