set serveroutput on size 10000;
set linesize 256;
define csize=500 
 
set verify off 
declare 
    Qmgr     CHAR(48) := 'TORPEDO';
    Qname    CHAR(48) := 'TEST.QUEUE';
    @MQSERIES.con
    hConn    binary_integer;
    hObj     binary_integer;
    CompCode binary_integer;
    Reason   binary_integer;
    od       mqseries.mqpack.MQOD;
    md       mqseries.mqpack.MQMD;
    pmo      mqseries.mqpack.MQPMO;
    rawbuff  RAW(50)  := RPAD('0',99,'0');     /* must initialize */
    charbuff CHAR(50) := 'Test message from PLSQL program.';
    O_Options  binary_integer;
    C_Options  binary_integer;
begin 
    mqseries.mqpack.MQCONN(Qmgr,hConn,CompCode,Reason); 
    dbms_output.put_line('MQCONN: CompCode='||CompCode||' Reason='||Reason);
    od.ObjectName := Qname;
    O_Options := MQOO_OUTPUT + MQOO_FAIL_IF_QUIESCING;
    mqseries.mqpack.MQOPEN(hConn,od,O_Options,hObj,CompCode,Reason);
    dbms_output.put_line('MQOPEN: CompCode='||CompCode||' Reason='||Reason);
    mqseries.mqpack.CHARtoRAW(rawbuff,1,50,charbuff,1);
    mqseries.mqpack.MQPUT(hConn,hObj,md,pmo,50,rawbuff,CompCode,Reason);
    dbms_output.put_line('MQPUT: CompCode='||CompCode||' Reason='||Reason);
    C_Options := MQCO_NONE;
    mqseries.mqpack.MQCLOSE(hConn,hObj,C_Options,CompCode,Reason);
    dbms_output.put_line('MQCLOSE: CompCode='||CompCode||' Reason='||Reason);
    mqseries.mqpack.MQDISC(hConn,CompCode,Reason);
    dbms_output.put_line('MQDISC: CompCode='||CompCode||' Reason='||Reason);
end; 
/ 
