set serveroutput on size 10000;
set linesize 256;
define csize=500 
 
set verify off 
declare 
    @MQSERIES.con
    Qmgr       CHAR(48) := 'TORPEDO';
    Qname      CHAR(48) := 'TEST.QUEUE';
    hConn      binary_integer;
    hObj       binary_integer;
    CompCode   binary_integer;
    Reason     binary_integer;
    od         mqpack.MQOD;
    md         mqpack.MQMD;
    pmo        mqpack.MQPMO;
    bo         mqpack.MQBO;
    rawbuff    RAW(32000)  := RPAD('0',63999,'0');     /* must initialize */
    key        binary_integer;
    data       varchar(32000);
    O_Options  binary_integer;
    C_Options  binary_integer;
    rc         binary_integer;
    eoc        boolean;
    cursor mq_cursor1 is
       select msg_id, msg_data from mqseries.mqmsgs;
begin 
    mqpack.MQCONN(Qmgr,hConn,CompCode,Reason); 
    dbms_output.put_line('MQCONN: CompCode='||CompCode||' Reason='||Reason||' '||hConn);

    od.ObjectName := Qname;
    O_Options := MQOO_OUTPUT + MQOO_FAIL_IF_QUIESCING;
    mqpack.MQOPEN(hConn,od,O_Options,hObj,CompCode,Reason);
    dbms_output.put_line('MQOPEN: CompCode='||CompCode||' Reason='||Reason);

    open mq_cursor1;
    eoc := false;
    while not eoc loop
       fetch mq_cursor1 into key, data;
       if mq_cursor1%NOTFOUND then
          eoc := true;
       else
          dbms_output.put_line('msg='||data||'<');

          mqpack.MQBEGIN(hConn,bo,CompCode,Reason);
          dbms_output.put_line('MQBEGIN: CompCode='||CompCode||' Reason='||Reason);

          -- insert the message to mqseries
          mqpack.CHARtoRAW(rawbuff,1,length(data),data,1);
          pmo.options := MQPMO_SYNCPOINT;
          mqpack.MQPUT(hConn,hObj,md,pmo,length(data),rawbuff,CompCode,Reason);
          dbms_output.put_line('MQPUT: CompCode='||CompCode||' Reason='||Reason);

          -- delete the row from the table
          rc := mqpack.xasql('DB', 'mqseries.mqdel', key);
          dbms_output.put_line('mqdel: rc='||rc);

          -- if the key is an even number, to MQCMIT, else to MQBACK        
          if mod(key,2) = 1 then
             mqpack.MQBACK(hConn,CompCode,Reason);
             dbms_output.put_line('MQBACK: CompCode='||CompCode||' Reason='||Reason);
          else 
             mqpack.MQCMIT(hConn,CompCode,Reason);
             dbms_output.put_line('MQCMIT: CompCode='||CompCode||' Reason='||Reason);
          end if;

       end if;
    end loop;
    close mq_cursor1;

    C_Options := MQCO_NONE;
    mqpack.MQCLOSE(hConn,hObj,C_Options,CompCode,Reason);
    dbms_output.put_line('MQCLOSE: CompCode='||CompCode||' Reason='||Reason);

    mqpack.MQDISC(hConn,CompCode,Reason);
    dbms_output.put_line('MQDISC: CompCode='||CompCode||' Reason='||Reason);
end; 
/ 
