set serveroutput on size 10000;
set linesize 256;
define csize=500 
 
set verify off 
declare 
    @MQSERIES.con
    Qmgr       CHAR(48) := 'TORPEDO';
    Qname      CHAR(48) := 'TEST.QUEUE';
    hConn      binary_integer;
    hObj       binary_integer;
    CompCode   binary_integer;
    Reason     binary_integer;
    od         mqpack.MQOD;
    md_init    mqpack.MQMD;
    md         mqpack.MQMD;
    gmo_init   mqpack.MQGMO;
    gmo        mqpack.MQGMO;
    bo         mqpack.MQBO;
    rawbuff    RAW(32000)  := RPAD('0',63999,'0');     /* must initialize */
    data       varchar(32000) := RPAD(' ',31999,' ');     /* must initialize */ 
    mlen       binary_integer;
    O_Options  binary_integer;
    C_Options  binary_integer;
    rc         binary_integer;
    eoc        boolean;
    counter    binary_integer := 0;
    cursor mq_cursor1 is
       select msg_id, msg_data from mqseries.mqmsgs;
begin 
    mqpack.MQCONN(Qmgr,hConn,CompCode,Reason); 
    dbms_output.put_line('MQCONN: CompCode='||CompCode||' Reason='||Reason||' '||hConn);

    od.ObjectName := Qname;
    O_Options := MQOO_INPUT_SHARED + MQOO_FAIL_IF_QUIESCING;
    mqpack.MQOPEN(hConn,od,O_Options,hObj,CompCode,Reason);
    dbms_output.put_line('MQOPEN: CompCode='||CompCode||' Reason='||Reason);

    eoc := false;
    while not eoc loop

       -- begin global transaction
       mqpack.MQBEGIN(hConn,bo,CompCode,Reason);
       dbms_output.put_line('MQBEGIN: CompCode='||CompCode||' Reason='||Reason);

       -- get a message from the queue
       gmo := gmo_init;
       md := md_init;
       gmo.Options := MQGMO_WAIT + MQPMO_SYNCPOINT;
       gmo.WaitInterval := 15000;
       mqpack.MQGET(hConn,hObj,md,gmo,32000,rawbuff,mlen,CompCode,Reason);
       dbms_output.put_line('MQGET: CompCode='||CompCode||' Reason='||Reason);

       if CompCode = 0 then

          data := RPAD(' ',31999,' ');
          mqpack.RAWtoVARCHAR(data,1,mlen,rawbuff,1);
          data := substr(data,1,mlen);
          dbms_output.put_line('message <'||data||'>');

          -- insert the message to the table
          rc := mqpack.xasql('DB', 'mqseries.mqisrt', data);
          dbms_output.put_line('mqisrt: rc='||rc);

          -- commit the first 2 messages, on the 3rd message, rollback and exit
          counter := counter + 1;
          if counter < 3 then
             mqpack.MQCMIT(hConn,CompCode,Reason);
             dbms_output.put_line('MQCMIT: CompCode='||CompCode||' Reason='||Reason);
          else
             mqpack.MQBACK(hConn,CompCode,Reason);
             dbms_output.put_line('MQBACK: CompCode='||CompCode||' Reason='||Reason);
             eoc := true;
          end if;

       else

          eoc := true;
    
       end if; 

    end loop;

    C_Options := MQCO_NONE;
    mqpack.MQCLOSE(hConn,hObj,C_Options,CompCode,Reason);
    dbms_output.put_line('MQCLOSE: CompCode='||CompCode||' Reason='||Reason);

    mqpack.MQDISC(hConn,CompCode,Reason);
    dbms_output.put_line('MQDISC: CompCode='||CompCode||' Reason='||Reason);
end; 
/ 
